//+------------------------------------------------------------------+
//|                                             JukeBoxIndicator.mq4 |
//|         (     JukeBoxExpert)|
//|                                     Copyright  2006, Widowmaker |
//|                                       mailto:a_g_j_@hotmail.com  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Widowmaker"
#property link      "mailto:a_g_j_@hotmail.com"
//
#property indicator_separate_window
#property indicator_level1   0.0
#property indicator_minimum -1.05
#property indicator_maximum  1.05
#property indicator_buffers  4
#property indicator_color1 Gold
#property indicator_color2 Red
#property indicator_color3 Lime
#property indicator_color4 Aqua
//
#define CountBarsMax 360
//
#import "ClusterPairs.dll"
/*
MT4_EXPFUNC double __stdcall GetNormDiffIndexPair(
                             int    p_num,  int n_bars,     double eye,
                             double alfa,   double v_shift, double k_0, 
                             double p_eurusd [],    double p_gbpusd [],
                             double p_usdchf [],    double p_usdjpy [],
                             double p_eurgbp [],    double p_eurchf [],
                             double p_eurjpy [],    double p_gbpchf [],
                             double p_gbpjpy [],    double p_chfjpy [],
                             double idif_p   [],    double idif_n   [],
                             double idif_d   [],    double idif_q   []
                                                    )
*/
// imported functions
// Pair
double GetNormDiffIndexPair(int, int, double, double, double, double, 
                                 double p_eurusd [],  double p_gbpusd [],
                                 double p_usdchf [],  double p_usdjpy [],
                                 double p_eurgbp [],  double p_eurchf [],
                                 double p_eurjpy [],  double p_gbpchf [],
                                 double p_gbpjpy [],  double p_chfjpy [],
                                 double idif_p   [],  double idif_n   [],
                                 double idif_d   [],  double idif_q   []);

#import
//---- input parameters
extern int    CountBars = 360;
extern double Eye       = 2.5;
extern double Alfa      = 0.5;
extern double VShift    = 0.0;
//---- buffers
double x[];
double y[];
double z[];
double t[];
double p_eurusd[]; 
double p_gbpusd[], p_usdchf[], p_usdjpy[];
double p_eurgbp[], p_eurchf[], p_eurjpy[];
double p_gbpchf[], p_gbpjpy[], p_chfjpy[];
double idiff_p[], idiff_n[], idiff_d[], idiff_q[];
double Buf_PairIndex[], Buf_PairNom[], Buf_PairDen[], Buf_SumSquares[];
//---- variables
double p_max;
double p_min;
//
//+------------------------------------------------------------------+
//| Initialize work arrays                                           |
//+------------------------------------------------------------------+
void InitOpArrays()
 {
  int ArrSize;
 //----
  // - Temporary Arrays -
  ArrSize = ArrayResize(x, CountBars);
  ArrSize = ArrayInitialize(x, 0.);
  ArrSize = ArrayResize(y, CountBars);
  ArrSize = ArrayInitialize(y, 0.);
  ArrSize = ArrayResize(z, CountBars);
  ArrSize = ArrayInitialize(z, 0.);
  ArrSize = ArrayResize(t, CountBars);
  ArrSize = ArrayInitialize(t, 0.);
  // -1- EURUSD
  ArrSize = ArrayResize(p_eurusd, CountBars);
  ArrSize = ArrayInitialize(p_eurusd, 0.);
  // -2- GBPUSD
  ArrSize = ArrayResize(p_gbpusd, CountBars);
  ArrSize = ArrayInitialize(p_gbpusd, 0.);
  // -3- USDCHF
  ArrSize = ArrayResize(p_usdchf, CountBars);
  ArrSize = ArrayInitialize(p_usdchf, 0.);
  // -4- USDJPY
  ArrSize = ArrayResize(p_usdjpy, CountBars);
  ArrSize = ArrayInitialize(p_usdjpy, 0.);
  // -5- EURGBP
  ArrSize = ArrayResize(p_eurgbp, CountBars);
  ArrSize = ArrayInitialize(p_eurgbp, 0.);
  // -6- EURCHF
  ArrSize = ArrayResize(p_eurchf, CountBars);
  ArrSize = ArrayInitialize(p_eurchf, 0.);
  // -7- EURJPY
  ArrSize = ArrayResize(p_eurjpy, CountBars);
  ArrSize = ArrayInitialize(p_eurjpy, 0.);
  // -8- GBPCHF
  ArrSize = ArrayResize(p_gbpchf, CountBars);
  ArrSize = ArrayInitialize(p_gbpchf, 0.);
  // -9- GBPJPY
  ArrSize = ArrayResize(p_gbpjpy, CountBars);
  ArrSize = ArrayInitialize(p_gbpjpy, 0.);
  // -10- CHFJPY
  ArrSize = ArrayResize(p_chfjpy, CountBars);
  ArrSize = ArrayInitialize(p_chfjpy, 0.);
  // - Pair Index -
  ArrSize = ArrayResize(idiff_p, CountBars);
  ArrSize = ArrayInitialize(idiff_p, 0.);
  // - Pair Nominator -
  ArrSize = ArrayResize(idiff_n, CountBars);
  ArrSize = ArrayInitialize(idiff_n, 0.);
  // - Pair Denominator -
  ArrSize = ArrayResize(idiff_d, CountBars);
  ArrSize = ArrayInitialize(idiff_d, 0.);
  // - SQRT(SUM_SQUARES_INDEXES) -
  ArrSize = ArrayResize(idiff_q, CountBars);
  ArrSize = ArrayInitialize(idiff_q, 0.);
 //----
  return;
 }
//+------------------------------------------------------------------+
//|          |
//+------------------------------------------------------------------+
/*
     :
 double t[]      //   -
     :
 int    n_bars   //     
 string s_symbol //   
 int    t_frame  //  
     :
 int    err_code //   ; 0 -   
     :
 double z[]      //      (O+H+L+C)/4
 double p_max;   //    n_bars 
 double p_min;   //    n_bars 
*/
int GetArray(int n_bars, string s_symbol, int t_frame)
 {
  int    n_copied;  //  -   
  int    err_code;  //  
  int    i;         // 
  double p_curr;    //  
 //----
  //
  for (i = n_bars-1; i >= 0; i--) { z[i] = 0.0; }
  //
  n_copied = ArrayCopySeries(t, MODE_OPEN, s_symbol, t_frame);
  err_code = GetLastError();
  for (i = n_bars-1; i >= 0; i--) { z[n_bars-1-i] += t[i]; }
  //
  n_copied = ArrayCopySeries(t, MODE_LOW, s_symbol, t_frame);
  err_code = GetLastError();
  for (i = n_bars-1; i >= 0; i--) { z[n_bars-1-i] += t[i]; }
  //
  n_copied = ArrayCopySeries(t, MODE_HIGH, s_symbol, t_frame);
  err_code = GetLastError();
  for (i = n_bars-1; i >= 0; i--) { z[n_bars-1-i] += t[i]; }
  //
  n_copied = ArrayCopySeries(t, MODE_CLOSE, s_symbol, t_frame);
  err_code = GetLastError();
  for (i = n_bars-1; i >= 0; i--) { z[n_bars-1-i] += t[i]; }
  //
  p_max = -999999999.0;                            //  
  p_min =  999999999.0;                             //  
  //
  for (i = n_bars-1; i >= 0; i--)
   {
    p_curr = z[i] / 4.0;
    z[i] = p_curr;
    if (p_curr >= p_max) { p_max = p_curr; }
    if (p_curr <= p_min) { p_min = p_curr; }
   }
 //----
  return(err_code);
 }
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
/*
     :
 double z[]        //      (O+H+L+C)/4
     :
 int n_bars        //     
 int t_frame       //  
     :
 int err_code      //   ; 0 -   
     :
 double p_eurusd[] //     EURUSD (O+H+L+C)/4
 double p_gbpusd[] //     GBPUSD (O+H+L+C)/4
 double p_usdchf[] //     USDCHF (O+H+L+C)/4
 double p_usdjpy[] //     USDJPY (O+H+L+C)/4
 double p_eurgbp[] //     EURGBP (O+H+L+C)/4
 double p_eurchf[] //     EURCHF (O+H+L+C)/4
 double p_eurjpy[] //     EURJPY (O+H+L+C)/4
 double p_gbpchf[] //     GBPCHF (O+H+L+C)/4
 double p_gbpjpy[] //     GBPJPY (O+H+L+C)/4
 double p_chfjpy[] //     CHFJPY (O+H+L+C)/4
*/
int GetWPPriceArrays(int n_bars, int t_frame)
 {
  double err_code;
  int    i;
  //----
  // -1- EURUSD
  err_code = GetArray(n_bars, "EURUSD", t_frame);
  for (i = 0; i <= n_bars - 1; i++) { p_eurusd[i] = z[i]; }
  // -2- GBPUSD
  err_code = GetArray(n_bars, "GBPUSD", t_frame);
  for (i = 0; i <= n_bars - 1; i++) { p_gbpusd[i] = z[i]; }
  // -3- USDCHF
  err_code = GetArray(n_bars, "USDCHF", t_frame);
  for (i = 0; i <= n_bars - 1; i++) { p_usdchf[i] = z[i]; }
  // -4- USDJPY
  err_code = GetArray(n_bars, "USDJPY", t_frame);
  for (i = 0; i <= n_bars - 1; i++) { p_usdjpy[i] = z[i]; }
  // -5- EURGBP
  err_code = GetArray(n_bars, "EURGBP", t_frame);
  for (i = 0; i <= n_bars - 1; i++) { p_eurgbp[i] = z[i]; }
  // -6- EURCHF
  err_code = GetArray(n_bars, "EURCHF", t_frame);
  for (i = 0; i <= n_bars - 1; i++) { p_eurchf[i] = z[i]; }
  // -7- EURJPY
  err_code = GetArray(n_bars, "EURJPY", t_frame);
  for (i = 0; i <= n_bars - 1; i++) { p_eurjpy[i] = z[i]; }
  // -8- GBPCHF
  err_code = GetArray(n_bars, "GBPCHF", t_frame);
  for (i = 0; i <= n_bars - 1; i++) { p_gbpchf[i] = z[i]; }
  // -9- GBPJPY
  err_code = GetArray(n_bars, "GBPJPY", t_frame);
  for (i = 0; i <= n_bars - 1; i++) { p_gbpjpy[i] = z[i]; }
  // -10- CHFJPY
  err_code = GetArray(n_bars, "CHFJPY", t_frame);
  for (i = 0; i <= n_bars - 1; i++) { p_chfjpy[i] = z[i]; }
  //----
   return(err_code);
 }
//+------------------------------------------------------------------+
//|            |
//+------------------------------------------------------------------+
/*
     :
 double p_eurusd[]       //     EURUSD (O+H+L+C)/4
 double p_gbpusd[]       //     GBPUSD (O+H+L+C)/4
 double p_usdchf[]       //     USDCHF (O+H+L+C)/4
 double p_usdjpy[]       //     USDJPY (O+H+L+C)/4
 double p_eurgbp[]       //     EURGBP (O+H+L+C)/4
 double p_eurchf[]       //     EURCHF (O+H+L+C)/4
 double p_eurjpy[]       //     EURJPY (O+H+L+C)/4
 double p_gbpchf[]       //     GBPCHF (O+H+L+C)/4
 double p_gbpjpy[]       //     GBPJPY (O+H+L+C)/4
 double p_chfjpy[]       //     CHFJPY (O+H+L+C)/4
     :
 int num_pair            //    
 int n_bars              //     
 double d_eye            //  Eye ( "")
 double d_alfa           //  Alfa ( )
 double v_shift          //  VShift (" ")
 double k_0              // " " (k_0 = 1.0 / Point)
     :
 int err_code            //   ; 0 -   
      -  :
 double Buf_PairIndex[]  //   
 double Buf_PairNom[]    //     
 double Buf_PairDen[]    //     
 double Buf_SumSquares[] //      
                         //    
*/
int GetIndBuffers(int num_pair, int n_bars, double d_eye,
                                double d_alfa, double v_shift, double k_0)
 {
  int err_code = 0;
  int i;
 //----
  err_code = GetNormDiffIndexPair(num_pair, 
                                  n_bars, d_eye, d_alfa, v_shift, k_0,
                                  p_eurusd, p_gbpusd, p_usdchf, p_usdjpy,
                                  p_eurgbp, p_eurchf, p_eurjpy, p_gbpchf, 
                                  p_gbpjpy, p_chfjpy, idiff_p,  idiff_n, 
                                                      idiff_d,  idiff_q);
  //Print(err_code);
  for (i = 0; i <= n_bars - 1; i++)
   {
    Buf_PairIndex [i] = idiff_p[n_bars-i-1]; 
    Buf_PairNom   [i] = idiff_n[n_bars-i-1]; 
    Buf_PairDen   [i] = idiff_d[n_bars-i-1]; 
    Buf_SumSquares[i] = idiff_q[n_bars-i-1];
   }
 //----
  return(err_code);
 }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
 {
 //----
  InitOpArrays();
  //---- indicators
  IndicatorShortName(Symbol() + " (" + Period() + "): ");
  SetIndexLabel(0, "DiffIndexPair: " + Symbol() + "(" + Period() + ") ");
  SetIndexStyle(0, DRAW_LINE);
  SetIndexBuffer(0, Buf_PairIndex);
  //
  SetIndexLabel(1, "DiffIndexNom: " + StringSubstr(Symbol(), 0, 3) + "(" + 
                                                   Period() + ") ");
  SetIndexStyle(1, DRAW_LINE);
  SetIndexBuffer(1, Buf_PairNom);
  //
  SetIndexLabel(2, "DiffIndexDen: " + StringSubstr(Symbol(), 3, 3) + "(" + 
                                                   Period() + ") ");
  SetIndexStyle(2, DRAW_LINE);
  SetIndexBuffer(2, Buf_PairDen);
  //
  SetIndexLabel(3, "DiffSumAllIndexes: (" + Period() + ") ");
  SetIndexStyle(3, DRAW_LINE);
  SetIndexBuffer(3, Buf_SumSquares);
  //
 //----
  return(0);
 }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
 {
 //----
 //  
 //----
  return(0);
 }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
 {
  int    i;
  double err_code;
 //----
  //          -
  err_code = GetWPPriceArrays(CountBars, 0);
  //         
  // -1- EURUSD
  if (Symbol() == "EURUSD")
   { 
    err_code = GetIndBuffers(1, CountBars, Eye, Alfa, VShift, (1.0/Point)); 
    return(0); 
   }
  // -2- GBPUSD
  if (Symbol() == "GBPUSD")
   { 
    err_code = GetIndBuffers(2, CountBars, Eye, Alfa, VShift, (1.0/Point)); 
    return(0); 
   }
  // -3- USDCHF
  if (Symbol() == "USDCHF")
   { 
    err_code = GetIndBuffers(3, CountBars, Eye, Alfa, VShift, (1.0/Point)); 
    return(0); 
   }
  // -4- USDJPY
  if (Symbol() == "USDJPY")
   { 
    err_code = GetIndBuffers(4, CountBars, Eye, Alfa, VShift, (1.0/Point)); 
    return(0); 
   }
  // -5-
  if (Symbol() == "EURGBP")
   { 
    err_code = GetIndBuffers(5, CountBars, Eye, Alfa, VShift, (1.0/Point)); 
    return(0); 
   }
  // -6- EURGBP
  if (Symbol() == "EURCHF")
   { 
    err_code = GetIndBuffers(6, CountBars, Eye, Alfa, VShift, (1.0/Point)); 
    return(0); 
   }
  // -7- EURJPY
  if (Symbol() == "EURJPY")
   { 
    err_code = GetIndBuffers(7, CountBars, Eye, Alfa, VShift, (1.0/Point)); 
    return(0); 
   }
  // -8- GBPCHF
  if (Symbol() == "GBPCHF")
   { 
    err_code = GetIndBuffers(8, CountBars, Eye, Alfa, VShift, (1.0/Point)); 
    return(0); 
   }
  // -9- GBPJPY
  if (Symbol() == "GBPJPY")
   { 
    err_code = GetIndBuffers(9, CountBars, Eye, Alfa, VShift, (1.0/Point)); 
    return(0); 
   }
  // -10- CHFJPY
  if (Symbol() == "CHFJPY")
   { 
    err_code = GetIndBuffers(10, CountBars, Eye, Alfa, VShift, (1.0/Point)); 
    return(0); 
   }
 //----
  return(0);
 }
//+------------------------------------------------------------------+