// ClusterPairs.cpp : Defines the entry point for the DLL application.
//
#include "stdafx.h"
#include "ClusterPairs.h"
#include "math.h"
#include "stdio.h"
#include "stdlib.h"
#include <iostream>
using namespace std;
//
#define MT4_EXPFUNC __declspec(dllexport)
//
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
 switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
		break;
 }
  return TRUE;
}
//
// This is an example of an exported variable
CLUSTERPAIRS_API int nClusterPairs=0;
//
// This is an example of an exported function.
CLUSTERPAIRS_API int fnClusterPairs(void)
{
	return 42;
}
//
// This is the constructor of a class that has been exported.
// see ClusterPairs.h for the class definition
CClusterPairs::CClusterPairs()
{ 
	return; 
}
//
//*************************************************************************//
//
// ---- FLOAT POINT CONSTANTS ----
#define PI     3.1415926535   // pi
#define EPS    0.000000001    // 1e-09
//
// ---- FIXED POINT CONSTANTS ----
#define NN_MAX 750  //     
#define NN_MIN  10  //     
#define VB_MAX  20  //     -  
#define VB_MIN -20  //     -  
#define ND_MAX  50  //     
//
// ---- BUFFERS - STATIC ARRAYS! ----
//  
double p_eurusd[NN_MAX]; //    EURUSD (O+H+L+C)/4
double p_gbpusd[NN_MAX]; //    GBPUSD (O+H+L+C)/4
double p_usdchf[NN_MAX]; //    USDCHF (O+H+L+C)/4
double p_usdjpy[NN_MAX]; //    USDJPY (O+H+L+C)/4
double p_eurgbp[NN_MAX]; //    EURGBP (O+H+L+C)/4
double p_eurchf[NN_MAX]; //    EURCHF (O+H+L+C)/4
double p_eurjpy[NN_MAX]; //    EURJPY (O+H+L+C)/4
double p_gbpchf[NN_MAX]; //    GBPCHF (O+H+L+C)/4
double p_gbpjpy[NN_MAX]; //    GBPJPY (O+H+L+C)/4
double p_chfjpy[NN_MAX]; //    CHFJPY (O+H+L+C)/4
//
//  
double ind_usd[NN_MAX];  //   USD
double ind_eur[NN_MAX];  //   EUR
double ind_gbp[NN_MAX];  //   GBP
double ind_chf[NN_MAX];  //   CHF
double ind_jpy[NN_MAX];  //   JPY
//
double idif_usd[NN_MAX]; //     USD
double idif_eur[NN_MAX]; //     EUR
double idif_gbp[NN_MAX]; //     GBP
double idif_chf[NN_MAX]; //     CHF
double idif_jpy[NN_MAX]; //     JPY
//
double idif_p[NN_MAX];  //    
double idif_n[NN_MAX];  //     
double idif_d[NN_MAX];  //     
double idif_q[NN_MAX];  // (idif_usd ^ 2 + idif_eur ^ 2 + 
                        //  idif_gbp ^ 2 + idif_chf ^ 2 + idif_jpy ^ 2) / 5.0
//
//  
double a[NN_MAX];        //  
double b[NN_MAX];        //  
double u[NN_MAX];        //  
double v[NN_MAX];        //  
double x[NN_MAX];        //  
double y[NN_MAX];        //  
double z[NN_MAX];        //  
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|   - (DCT) x[] --> y[]            |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
 double x[]           //  
     :
 int    n_bars        //     DCT-
     : 
     :
 double y[]           //  
*/
void DCT(int n_bars, double x [], double y [])
{ 
 int k;                                //    
 int n;                             //    
 double sum;                                                    // 
 double PIN2 = PI / (n_bars * 2.0);
 double wgt_zero = 1.0 / sqrt(n_bars);            //   0- 
 double wgt_nzero = sqrt(2.0) * wgt_zero;           //    
 //----
 // dct-
 for (k = 0; k < n_bars; k++)
 {                                                               //   k
  sum = 0.0;                                           //  
  for (n = 0; n < n_bars; n++)
  { sum += x[n] * cos(PIN2 * (2.0 * n + 1.0) * k); }             //   n
   if (k != 0)
   { y[k] = wgt_nzero * sum; } 
   else
   { y[k] = wgt_zero  * sum; }
  }                                                              //   k
 //----
 return;
} 
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|   - (IDCT) y[] --> x[]         |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
 double y[]           //  
     :
 int    n_bars        //     DCT-
     : 
     :
 double x[]           //  
*/
void IDCT(int n_bars, double x [], double y [])
{ 
 int k;                                //    
 int n;                             //    
 double sum;                                                    // 
 double PIN2 = PI / (n_bars * 2.0);
 double wgt_zero = 1.0 / sqrt(n_bars);            //   0- 
 double wgt_nzero = sqrt(2.0) * wgt_zero;           //    
 //----
 // idct-
 for (n = 0; n < n_bars; n++)
 {                                                               //   n
  sum = 0.0;                                           //  
  for (k = 0; k < n_bars; k++)
  {                                                              //   k
   if (k != 0)
   { sum += wgt_nzero * y[k] * cos(PIN2 * (2.0 * n + 1.0) * k); }
   else
   { sum += wgt_zero  * y[k] * cos(PIN2 * (2.0 * n + 1.0) * k); }
  }                                                              //   k
    x[n] = sum;
 }                                                               //   n
 //----
 return;
} 
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|     y[] --> y[] ( )    |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
 double y[]            //  
     :
 int    n_bars         //     
 double eye            //  ""
 double alfa           //  
     : 
     :
 double y[]            //      
*/
void GetDiffrLeftSide(int n_bars, double eye, double alfa, double y []) 
{
 double kern;   //
 double omega;  //
 double domega; //
 double omega2; // 1 + omega^2
 double delta = 2.0 * PI / (n_bars - 1);
 int i;
 //----
 for (i = 0; i < n_bars; i++)
 {
  omega  = i * delta;
  domega = omega * eye;
  omega2 = 1.0 + omega * omega;                  // 1. + omega^2
  kern   = (sin(domega) + EPS) / (domega + EPS); // sin(arg)/arg
  y[i]  = (kern * y[i]) / (kern * kern + alfa * omega2);
 }
 //----
 return;
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|    x[]  5 ;  - y[]         |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
 double x[]    //   - ;
     :
 int    n_beg  //   
 int    n_end  //   
     : 
     :   
 double y[]    //   - ;
*/
void GetSmooth5(int n_beg, int n_end, double x [], double y [])
{ 
 int i;
 //----
 y[n_beg] = (3.0 * x[n_beg] + 2.0 * x[n_beg+1] + 
                                    x[n_beg+2] - x[n_beg+4]) / 5.0;
 y[n_beg+1] = (4.0 * x[n_beg] + 3.0 * x[n_beg+1] + 
                                2.0 * x[n_beg+2] + x[n_beg+3]) / 10.0;
 for (i = n_beg + 2; i < n_end - 2; i++)
 { y[i] = (x[i-2] + x[i-1] + x[i] + x[i+1] + x[i+2]) / 5.0; }
 y[n_end-2] = (x[n_end-4] + 2.0 * x[n_end-3] + 
                            3.0 * x[n_end-2] + 4.0 * x[n_end-1]) / 10.0;
 y[n_end-1] = (3.0 * x[n_end-1] + 2.0 * x[n_end-2] + 
                                        x[n_end-3] - x[n_end-5]) / 5.0;
 //----
 return;
} 
//
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|   y[]      x[]       |//
//|  3-                                                          |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
 double x[]    //   - ;
     :
 int    n_beg  //   
 int    n_end  //   
     : 
     :   
 double y[]    //   - ;
*/
void GetDraftDeriv3(int n_beg, int n_end, double x [], double y [])
{ 
 int i;
//----
 y[n_beg] = (-3.0 * x[n_beg] + 4.0 * x[n_beg+1] - x[n_beg+2]) / 2.0;
 for (i = n_beg + 1; i < n_end - 1; i++) 
 { y[i] = (x[i+1] - x[i-1]) / 2.0; }
 y[n_end-1] = (3.0 * x[n_end-1] - 4.0 * x[n_end-2] + x[n_end-3]) / 2.0;
//----
 return;
} 
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|   y[]     x[]        |//
//|  5-                                                         |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
 double x[]    //   - ;
     :
 int    n_beg  //   ;
 int    n_end  //   ;
     : 
     :   
 double y[]    //   - ;
*/
void GetDraftDeriv5(int n_beg, int n_end, double x [], double y [])
{ 
 int i;
 //----
 y[n_beg] = (-25.0 * x[n_beg] + 48.0 * x[n_beg+1] - 36.0 * x[n_beg+2] + 
              16.0 * x[n_beg+3] - 3.0 * x[n_beg+4]) / 12.0;
 y[1] = (-3.0 * x[0] - 10.0 * x[1] + 18.0 * x[2] - 
                                      6.0 * x[3] + x[4]) / 12.0;
 for (i = n_beg + 2; i < n_end - 2; i++) 
 { y[i] = (x[i-2] - 8.0 * x[i-1] + 8.0 * x[i+1] - x[i+2]) / 12.0; }
 y[n_end-2] = (3.0 * x[n_end-1] + 10.0 * x[n_end-2] - 18.0 * x[n_end-3] + 
                                   6.0 * x[n_end-4] - x[n_end-5]) / 12.0;
 y[n_end-1] = (25.0 * x[n_end-1] - 48.0 * x[n_end-2] + 36.0 * x[n_end-3] - 
               16.0 * x[n_end-4] + 3.0 * x[n_end-5]) / 12.0;
 //----
 return;
} 
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|     x[]  y[]: y[.] = x[.] + y[.]        |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
 double x[]       //   1- ;
 double y[]       //   2- ;
     :
 int    n_beg     //   
 int    n_end     //   
     : 
     :
 double y[]       //  -   x[.] + y[.];
*/
void PairSumArrays(int n_beg, int n_end, double x [], double y [])
{
 int i;                                                            // 
 //
 //----
 for (i = n_beg; i < n_end; i++) { y[i] += x[i]; }
 //----
 return;
}
//
//*************************************************************************//
//#########################################################################//
//#                   MT4_EXPFUNC                  #//
//#########################################################################//
//*************************************************************************//
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|   DCT- ( )             |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
 double x[]     //     ();
     :
 int    n_bars  //     
 int    dct_on  //  : 1 - DCT, 0 -  (5 )
 double eye     //  ""
 double alfa    //   
     : 
 int nn_tot     //   
     :
 double x[]     //  -    ;
*/
MT4_EXPFUNC int __stdcall GetSmoothing (int nn_tot, int dct_on, double eye, 
                                                    double alfa, double x [])
{
 int err_code = 0;                                              //  
 int i;                                                            // 
 //
 // ########################### Error Definitions ###########################
 // *** :     ,  ***
 if (nn_tot > NN_MAX) 
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if (nn_tot < NN_MIN) 
 {  
	 err_code = -2;
	 return(err_code); 
 }  
 // *** :  alfa = 0  eye <> 0,  ***
 if ((alfa == 0.0) && (eye != 0.0)) 
 {  
	 err_code = -3;
	 return(err_code); 
 }  
 // *** :  eye_size < 0,  ***
 if (eye < 0.0) 
 {  
	 err_code = -4;
	 return(err_code); 
 }  
 // *** :  eye_alfa < 0,  ***
 if (alfa < 0.0) 
 { 
	 err_code = -5;
	 return(err_code); 
 }  
 // #########################################################################
 //
 //----
 //
 if (dct_on <= 0) { dct_on = 0; }
 if (dct_on >= 1) { dct_on = 1; }
 if (dct_on == 1)
 {
  DCT (nn_tot, x, y);                                          // x[] --> y[]
  GetDiffrLeftSide (nn_tot, eye, alfa, y);                     // y[] --> y[]
  IDCT (nn_tot, x, y);                                         // y[] --> x[]
  GetSmooth5 (0, nn_tot, x, y);                                // x[] --> y[]
  for (i = 0; i < nn_tot; i++) { x[i] = y[i]; }                // y[] --> x[]
 }
 else
 {
  GetSmooth5 (0, nn_tot, x, y);                                // x[] --> y[]
  for (i = 0; i < nn_tot; i++) { x[i] = y[i]; }                // y[] --> x[]
 }
 //
 //----
 err_code = nn_tot;
 return(err_code);
}
//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|                |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
 double x[]    //    ;
     :
 int    n_beg  //   
 int    n_end  //   
 double v_max  //     ;
 double v_min  //     ;
     : 
     :
 double x[]    //  -    ;
*/
MT4_EXPFUNC int __stdcall NormRange(int n_beg, int n_end, 
                                    double v_max, double v_min, double x [])
{ 
 int    err_code = 0;                              //   
 double x_max;                 //     
 double x_min;                  //     
 double x_curr;                           //   
 double x_norm;                             //   
 double coef_1;                              // 1-  
 double coef_2;                              // 2-  
 double diff_x;                                     //  x_max - x_min
 int    n_bars;                                              // n_end - n_beg
 int    i;                                                         // 
 //
 n_bars = n_end - n_beg;
 // ########################### Error Definitions ###########################
 // *** :       ,  ***
 if (n_bars < 0) 
 { 
	 err_code = -6;
	 return(err_code); 
 } 
 // *** :     ,  ***
 if ((n_bars > 0) && (n_bars > NN_MAX))
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if ((n_bars > 0) && (n_bars < NN_MIN))
 {  
	 err_code = -2;
	 return(err_code); 
 }  
 // #########################################################################
 //
 //----
 //       
 x_min =  999999999.0;
 x_max = -999999999.0;
 for (i = n_beg; i < n_end; i++)
 { 
  x_curr = x[i];
  if (x_curr >= x_max) { x_max = x_curr; }
  if (x_curr <= x_min) { x_min = x_curr; }
 } 
 diff_x = x_max - x_min;
 //
 // ########################### Error Definitions ###########################
 // *** : diff_x = 0 ***
 if (diff_x == 0.0)
 {
  err_code = -7;
  return(err_code);
 }
 // #########################################################################
 //
 //      
 coef_1 = (v_min * x_max - v_max * x_min) / diff_x;
 coef_2 = (v_max - v_min) / diff_x;
 //     
 for (i = n_beg; i < n_end; i++)
 { 
  x_curr = x[i];
  x_norm = coef_1 + x_curr * coef_2;
  x[i]   = x_norm;
 } 
 //----
 return(err_code);
} 
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|     " "                |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
 double x[]       //    ;
     :
 int    n_beg     //   
 int    n_end     //   
     : 
 double max_true; // " " [max(|max_val|,|min_val|)]
     :
 double x[]       //  -    ;
*/
MT4_EXPFUNC double __stdcall NormToTrueMax(int n_beg, int n_end, double x [])
{ 
 double err_code = 0.0;                            //   
 double x_curr;                           //   
 double x_max;                 //     
 double x_min;                  //     
 double max_true;           // " " [max(|max_val|,|min_val|)]
 int    n_bars;                                              // n_end - n_beg
 int    i;                                                         // 
 //
 n_bars = n_end - n_beg;
 // ########################### Error Definitions ###########################
 // *** :       ,  ***
 if (n_bars < 0) 
 { 
	 err_code = -6;
	 return(err_code); 
 } 
 // *** :     ,  ***
 if ((n_bars > 0) && (n_bars > NN_MAX))
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if ((n_bars > 0) && (n_bars < NN_MIN))
 {  
	 err_code = -2;
	 return(err_code); 
 }  
 // #########################################################################
 //----
 //
 //       
 x_min =  999999999.0;
 x_max = -999999999.0;
 for (i=n_beg; i<n_end; i++)
 { 
  x_curr = x[i];
  if (x_curr >= x_max) { x_max = x_curr; }
  if (x_curr <= x_min) { x_min = x_curr; }
 } 
 //  " " max_true = max(|max_val|,|min_val|)
 x_max = fabs(x_max);
 x_min = fabs(x_min);
 if (x_max >= x_min) 
 { max_true = x_max; }
 else
 { max_true = x_min; }
 //
 // ########################### Error Definitions ###########################
 // *** : max_true = 0 ***
 if (max_true == 0.0)
 {
  err_code = -7;
  return(err_code);
 }
 // #########################################################################
 //
 //    " "
 for (i=n_beg; i<n_end; i++) { x[i] = x[i] / max_true; }
 //----
 err_code = max_true;
 return(err_code);  //   -  " "
}  
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|                  |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
 double x[]       //    ;
     :
 int    n_beg     //   
 int    n_end     //   
     : 
 double err_code; //   ; n_bars -   
     :
 double x[]       //  -    ;
*/
MT4_EXPFUNC int __stdcall NormToHypTan(int n_beg, int n_end, double x [])
{ 
 double err_code = 0;                              //   
 double x_exp;                                                         // e^x
 double r_exp;                                                      // e^(-x)
 int    n_bars;                                              // n_end - n_beg
 int    i;                                                         // 
 //
 n_bars = n_end - n_beg;
 // ########################### Error Definitions ###########################
 // *** :       ,  ***
 if (n_bars < 0) 
 { 
	 err_code = -6;
	 return(err_code); 
 } 
 // *** :     ,  ***
 if ((n_bars > 0) && (n_bars > NN_MAX))
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if ((n_bars > 0) && (n_bars < NN_MIN))
 {  
	 err_code = -2;
	 return(err_code); 
 }  
 // #########################################################################
 //----
 for (i=n_beg; i<n_end; i++)
 {
  x_exp = exp(x[i]);
  r_exp = 1.0 / x_exp;
  x[i]  = (x_exp - r_exp) / (x_exp + r_exp);
 }
 //----
 err_code = n_bars;
 return(err_code);
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|           |//
//| x[]  y[]; : z[.] = rl(x,y) * x[.] * y[.]                    |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
 double x[]       //   1- ;
 double y[]       //   2- ;
     :
 int    n_beg     //   
 int    n_end     //   
     : 
 double rl_xy;    // rl(x,y) -    x[]  y[]
     :
 double z[]       //  -   rl(x,y) * x[.] * y[.];
*/
MT4_EXPFUNC double __stdcall GetPairCorrLinear(int n_beg,   int n_end, 
                                               double x [], double y [], 
                                                            double z [])
{
 double err_code = 0.0;           //   
 double rl_xy    = 0.0;           //    x[]  y[]
 double rl_nom   = 0.0;           // 
 double rl_den   = 0.0;           // 
 double sum_x    = 0.0;           // Sum(x[.])
 double sum_y    = 0.0;           // Sum(y[.])
 double sum_xy   = 0.0;           // Sum(x[.] * y[.])
 double sum_x2   = 0.0;           // Sum(x[.] * x[.])
 double sum_y2   = 0.0;           // Sum(y[.] * y[.])
 int    n_bars;                   //    
 int    i;                        // 
 //
 // ########################### Error Definitions ###########################
 n_bars = n_end - n_beg;
 // *** :       ,  ***
 if (n_bars < 0) 
 { 
	 err_code = -6;
	 return(err_code); 
 } 
 // *** :     ,  ***
 if ((n_bars > 0) && (n_bars > NN_MAX))
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if ((n_bars > 0) && (n_bars < NN_MIN))
 {  
	 err_code = -2;
	 return(err_code); 
 }  
 // #########################################################################
 //
 //----
 for (i = n_beg; i < n_end; i++)
 {
  sum_x  +=  x[i]; 
  sum_y  +=  y[i]; 
  sum_xy += (x[i] * y[i]); 
  sum_x2 += (x[i] * x[i]); 
  sum_y2 += (y[i] * y[i]);
 }
 rl_nom  = (sum_xy - (sum_x * sum_y) / n_bars);
 rl_den  = (sum_x2 - (sum_x * sum_x) / n_bars);
 rl_den *= (sum_y2 - (sum_y * sum_y) / n_bars);
 //
 // ########################### Error Definitions ###########################
 // *** : rl_den = 0 ***
 if (rl_den == 0.0)
 {
  err_code = -8;
  return(err_code);
 }
 // #########################################################################
 //
 rl_xy = (rl_nom / sqrt(rl_den));   //    
 //
 for (i = n_beg; i < n_end; i++) { z[i] = (rl_xy * x[i] * y[i]); }
 //----
 err_code = rl_xy ;
 return(err_code);   //   -   r(x,y)
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|              |//
//| x[]  y[]; : z[.] = rs(x,y) * x[.] * y[.]                    |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
 double x[]       //   1- ;
 double y[]       //   2- ;
     :
 int    n_beg     //   
 int    n_end     //   
     : 
 double rs_xy;    // r(x,y) -     x[]  y[] 
     :
 double z[]       //  -   rs(x,y) * x[.] * y[.];
 [double a[]      //     ]
 [double b[]      //     ]
*/
MT4_EXPFUNC double __stdcall GetPairCorrShape(int n_beg,   int n_end, 
                                              double x [], double y [], 
                                                           double z [])
{
 double err_code = 0.0;      //   
 double dif_xy   = 0.0;      //  x[.] - y[.]
 double sum_sq   = 0.0;      //    x[.] - y[.]
 double rs_xy    = 0.0;      //     x[]  y[]
 int    n_bars;              //    
 int    i;                   // 
 // ########################### Error Definitions ###########################
 n_bars = n_end - n_beg;
 // *** :       ,  ***
 if (n_bars < 0) 
 { 
	 err_code = -6;
	 return(err_code); 
 } 
 // *** :     ,  ***
 if ((n_bars > 0) && (n_bars > NN_MAX))
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if ((n_bars > 0) && (n_bars < NN_MIN))
 {  
	 err_code = -2;
	 return(err_code); 
 }  
 // #########################################################################
 //
 //----
 //   x[]  y[]   a[]  b[]
 for (i = n_beg; i < n_end; i++) { a[i] = x[i]; b[i] = y[i]; }
 //
 //   a[]  " "
 err_code = NormToTrueMax(n_beg, n_end, a);
 //
 // ########################### Error Definitions ###########################
 if (err_code == -7)   //       
 { 
  err_code = -8;
  return(err_code); 
 }                      //   -    
 // #########################################################################
 //
 //   b[]  " "
 err_code = NormToTrueMax(n_beg, n_end, b);
 //
 // ########################### Error Definitions ###########################
 if (err_code == -7)   //       
 {
  err_code = -8;
  return(err_code); 
 }                      //   -    
 // #########################################################################
 //
 //        
 for (i = n_beg; i < n_end; i++)
 {
  dif_xy  = (a[i] - b[i]);
  sum_sq += (dif_xy * dif_xy);
 }
 //     (1   )
 rs_xy = 1.0 - sqrt(sum_sq / n_bars);
 //    z[]
 for (i = n_beg; i < n_end; i++) { z[i] = (rs_xy * a[i] * b[i]); }
 //----
 err_code = rs_xy ;
 return(err_code);  //   -   rs(x,y)
}
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|       x[];       |//
//|  y[.] = k_0 * D(x[.])                                        |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
 double x[]       //   ;
     :
 int    n_beg     //   
 int    n_end     //   
 double k_0       // " " (k_0 = 1.0 / point_s)
     : 
 int    n_bars;   //    
     :
 double y[]       //  -   D(x[.])  ;
 [double u[]    //     ]
 [double v[]    //     ]
*/
MT4_EXPFUNC int __stdcall GetFirstDeriv(int n_beg, int n_end,   double k_0,
                                                   double x [], double y [])
{
 bool bderiv5_on = true;          //     5 
 int  err_code   = 0;                              //   
 int  n_bars;                                      //    
 int  i;                                                           // 
 //
 // ########################### Error Definitions ###########################
 n_bars = n_end - n_beg;
 // *** :       ,  ***
 if (n_bars < 0) 
 { 
	 err_code = -6;
	 return(err_code); 
 } 
 // *** :     ,  ***
 if ((n_bars > 0) && (n_bars > NN_MAX))
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if ((n_bars > 0) && (n_bars < NN_MIN))
 {  
	 err_code = -2;
	 return(err_code); 
 }  
 // #########################################################################
 //
 //----
 //   x[]  " " k_0 (k_0 = 1.0 / point_s)
 for (i = n_beg; i < n_end; i++) { u[i] = k_0 * x[i]; }
 //  1- ;   u[],   v[]
 if (bderiv5_on == false)
 { GetDraftDeriv3(n_beg, n_end, u, v); }         //   3- 
 else
 { GetDraftDeriv5(n_beg, n_end, u, v); }           //   5 
 //   5 ;   v[],   y[]
 GetSmooth5(n_beg, n_end, v, y);        //  y[] -  1- 
 //----
 err_code = n_bars;
 return(err_code);      //   -   
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|        x[]              |//
//|  v_shift  ;  -   y[.]         |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
 double x[]     //   ;
     :
 int n_beg      //   
 int n_end      //   
 double v_shift // " " -     
 double k_0     // " " (k_0 = 1.0 / point_s)
     : 
 int n_derivs;  //   
     :
 double y[]     //  -      ;
 [double u[]    //     ]
 [double v[]    //     ]
 [double z[]    //     ]
*/
MT4_EXPFUNC int __stdcall GetTaylorSum(int n_beg, int n_end, double v_shift,
                                       double k_0, double x [], double y [])
{
 bool   bderiv5_on = true;        //     5 
 int    err_code   = 0;                            //   
 int    n_bars;                                    //    
 int    i;                                              //   
 int    n_derivs;                                //    
 double vs_pj;                                          //  virt_shift^j
 double g_i;          //         i
 double err_sq;  //   (    )
 //
 n_bars = n_end - n_beg;
 // ########################### Error Definitions ###########################
 // *** :       ,  ***
 if (n_bars < 0) 
 { 
	 err_code = -6;
	 return(err_code); 
 } 
 // *** :     ,  ***
 if ((n_bars > 0) && (n_bars > NN_MAX))
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if ((n_bars > 0) && (n_bars < NN_MIN))
 {  
	 err_code = -2;
	 return(err_code); 
 }
 // :      , 
 if (v_shift > VB_MAX)
 {  
	 err_code = -10;
	 return(err_code); 
 } 
 // :      , 
 if (v_shift < VB_MIN)
 {  
	 err_code = -11;
	 return(err_code); 
 } 
 // #########################################################################
 //
 //----
 //   x[]  " " k_0 (k_0 = 1.0 / point_s)
 for (i = n_beg; i < n_end; i++) { u[i] = k_0 * x[i]; }
 //
 // ---- Calculate first n members of Taylor serie using Gorner scheme ----
 if (v_shift != 0)
 { 
  n_derivs = 0;        //    (  )
  vs_pj    = 1.0;                               //   vs_pj
  for (i = 0; i < n_bars; i++) { y[i] = 0.0; }       //  -
  //
  do     //        n  
  { 
   //  1- ;   u[],   v[]
   if (bderiv5_on == false)
   { GetDraftDeriv3(0, n_bars, u, v); }          //   3- 
   else
   { GetDraftDeriv5(0, n_bars, u, v); }            //   5 
   //   5 ;   v[],   z[]
   GetSmooth5(0, n_bars, v, z);         //  z[] -  1- 
   vs_pj *= v_shift / (n_derivs + 1);            //   
   err_sq = 0.0;             //    
   for (i = 0; i < n_bars; i++) 
   { 
    u[i] = z[i];  //  z[] -> u[]    
    g_i  = z[i] * vs_pj;         //       i
    err_sq += g_i * g_i;            //   
    y[i]   += g_i;                     //     
   } 
   err_sq = sqrt(err_sq) / n_bars;      //     
   n_derivs++;   //      ( )
   //     ,   
   if (n_derivs > ND_MAX) { break; }
  } 
  while (err_sq > EPS);                                   // end of 'do' loop
 } 
 else                                           //   v_shift = 0
 { 
  err_code = 0;         //   ,      
  return(err_code);
 } 
 //
 // ########################### Error Definitions ###########################
 // *** :   ;   ***
 if (n_derivs > ND_MAX)         //    
 { 
  err_code = -9;
  return(err_code);
 } 
 // #########################################################################
 //
 //----
 err_code = n_derivs;
 return(err_code);      //   -   
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|  ""     USD, EUR, GBP, CHF, |//
//| JPY       .       |//
//|    10  : EURUSD, GBPUSD, USDCHF,     |//
//| USDJPY, EURGBP, EURCHF, EURJPY, GBPCHF, GBPJPY, CHFJPY                |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
double p_eurusd[]; //    EURUSD (O+H+L+C)/4
double p_gbpusd[]; //    GBPUSD (O+H+L+C)/4
double p_usdchf[]; //    USDCHF (O+H+L+C)/4
double p_usdjpy[]; //    USDJPY (O+H+L+C)/4
double p_eurgbp[]; //    EURGBP (O+H+L+C)/4
double p_eurchf[]; //    EURCHF (O+H+L+C)/4
double p_eurjpy[]; //    EURJPY (O+H+L+C)/4
double p_gbpchf[]; //    GBPCHF (O+H+L+C)/4
double p_gbpjpy[]; //    GBPJPY (O+H+L+C)/4
double p_chfjpy[]; //    CHFJPY (O+H+L+C)/4
     :
int    n_bars      //     
int    dct_on      //  : 
                   // 1 - DCT, 0 -  (5 )
double eye         //  ""
double alfa        //   
     : 
double err_code;   //   ; f_corr -   
     :
double ind_usd[];  //   USD
double ind_eur[];  //   EUR
double ind_gbp[];  //   GBP
double ind_chf[];  //   CHF
double ind_jpy[];  //   JPY
*/
MT4_EXPFUNC double __stdcall GetRawClusterIndexes(int n_bars, int dct_on,
                             double eye,          double alfa,
                             double p_eurusd [],  double p_gbpusd [],
                             double p_usdchf [],  double p_usdjpy [],
                             double p_eurgbp [],  double p_eurchf [],
                             double p_eurjpy [],  double p_gbpchf [],
                             double p_gbpjpy [],  double p_chfjpy [],
                             double ind_usd  [],  double ind_eur  [],
                             double ind_gbp  [],  double ind_chf  [],
                                                  double ind_jpy  []
                                                 )
{
 double err_code = 0;                              //   
 double f_corr   = 1;       //      
 int i;                                                 //   
 //
 // ########################### Error Definitions ###########################
 // *** :     ,  ***
 if (n_bars > NN_MAX)
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if (n_bars < NN_MIN)
 {  
	 err_code = -2;
	 return(err_code); 
 }
 // *** :  alfa = 0  eye <> 0,  ***
 if ((alfa == 0.0) && (eye != 0.0)) 
 {  
	 err_code = -3;
	 return(err_code); 
 }  
 // *** :  eye_size < 0,  ***
 if (eye < 0.0) 
 {  
	 err_code = -4;
	 return(err_code); 
 }  
 // *** :  eye_alfa < 0,  ***
 if (alfa < 0.0) 
 { 
	 err_code = -5;
	 return(err_code); 
 }    
 // #########################################################################
 //
 //----
 //
 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 //
 //   ;      
 //
 err_code = GetSmoothing(n_bars, dct_on, eye, alfa, p_eurusd);      // EURUSD
 //
 err_code = GetSmoothing(n_bars, dct_on, eye, alfa, p_gbpusd);      // GBPUSD
 //
 err_code = GetSmoothing(n_bars, dct_on, eye, alfa, p_usdchf);      // USDCHF
 //
 err_code = GetSmoothing(n_bars, dct_on, eye, alfa, p_usdjpy);      // USDJPY
 //
 err_code = GetSmoothing(n_bars, dct_on, eye, alfa, p_eurgbp);      // EURGBP
 //
 err_code = GetSmoothing(n_bars, dct_on, eye, alfa, p_eurchf);      // EURCHF
 //
 err_code = GetSmoothing(n_bars, dct_on, eye, alfa, p_eurjpy);      // EURJPY
 //
 err_code = GetSmoothing(n_bars, dct_on, eye, alfa, p_gbpchf);      // GBPCHF
 // 
 err_code = GetSmoothing(n_bars, dct_on, eye, alfa, p_gbpjpy);      // GBPJPY
 //
 err_code = GetSmoothing(n_bars, dct_on, eye, alfa, p_chfjpy);      // CHFJPY
 //
 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 //
 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 //
 // (1)  ""  USD,  EURUSD, GBPUSD, USDCHF, USDJPY
 //
 //         EURUSD  GBPUSD
 for (i = 0; i < n_bars; i++) 
 { 
  ind_usd[i] = 0.0;                                   //  EURUSD  GBPUSD
  x[i] = 1.0 / p_eurusd[i];      //   EURUSD USD   
  y[i] = 1.0 / p_gbpusd[i];      //   GBPUSD USD   
 }
 // -------------------------------------------------------------------------
 // (i)     CovShape(1/EURUSD, 1/GBPUSD)
 err_code = GetPairCorrShape(0, n_bars, x, y, z);   //  -  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -110;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_usd[]: ind_usd[] *= z[]
 PairSumArrays(0, n_bars, z, ind_usd);
 // -------------------------------------------------------------------------
 // (ii)     CovShape(1/EURUSD, USDCHF)
 err_code = GetPairCorrShape(0, n_bars, x, p_usdchf, z);        //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -111;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_usd[]: ind_usd[] *= z[]
 PairSumArrays(0, n_bars, z, ind_usd);
 // -------------------------------------------------------------------------
 // (iii)     Covf(1/EURUSD, USDJPY)
 err_code = GetPairCorrShape(0, n_bars, x, p_usdjpy, z);        //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -112;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_usd[]: ind_usd[] *= z[]
 PairSumArrays(0, n_bars, z, ind_usd);
 // -------------------------------------------------------------------------
 // (iv)     CovShape(1/GBPUSD, USDJPY)
 err_code = GetPairCorrShape(0, n_bars, y, p_usdjpy, z);        //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -113;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_usd[]: ind_usd[] *= z[]
 PairSumArrays(0, n_bars, z, ind_usd);
 // -------------------------------------------------------------------------
 // (v)     CovShape(1/GBPUSD, USDCHF)
 err_code = GetPairCorrShape(0, n_bars, y, p_usdchf, z);        //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -114;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_usd[]: ind_usd[] *= z[]
 PairSumArrays(0, n_bars, z, ind_usd);
 // -------------------------------------------------------------------------
 // (vi)     CovShape(USDJPY, USDCHF)
 err_code = GetPairCorrShape(0, n_bars, p_usdjpy, p_usdchf, z); //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -115;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_usd[]: ind_usd[] *= z[]
 PairSumArrays(0, n_bars, z, ind_usd);
 // -------------------------------------------------------------------------
 //    USD  " "
 err_code = NormToTrueMax(0, n_bars, ind_usd);
 // ########################### Error Definitions ###########################
 if (err_code == -7) 
 { 
  err_code = -116;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //
 // -------------------------------------------------------------------------
 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 //
 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 //
 // (2)  ""  EUR,  EURUSD, EURGBP, EURCHF, EURJPY
 //
 //   
 for (i = 0; i < n_bars; i++) { ind_eur[i] = 0.0; }
 // -------------------------------------------------------------------------
 // (i)    Cov(EURUSD, EURGBP)
 err_code = GetPairCorrShape(0, n_bars, p_eurusd, p_eurgbp, z); //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -210;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_eur[]: ind_eur[] *= z[]
 PairSumArrays(0, n_bars, z, ind_eur);
 // -------------------------------------------------------------------------
 // (ii)     CovShape(EURUSD, EURCHF)
 err_code = GetPairCorrShape(0, n_bars, p_eurusd, p_eurchf, z); //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -211;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_eur[]: ind_eur[] *= z[]
 PairSumArrays(0, n_bars, z, ind_eur);
 // -------------------------------------------------------------------------
 // (iii)     CovShape(EURUSD, EURJPY)
 err_code = GetPairCorrShape(0, n_bars, p_eurusd, p_eurjpy, z); //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -212;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_eur[]: ind_eur[] *= z[]
 PairSumArrays(0, n_bars, z, ind_eur);
 // -------------------------------------------------------------------------
 // (iv)     CovShape(EURGBP, EURCHF)
 err_code = GetPairCorrShape(0, n_bars, p_eurgbp, p_eurchf, z); //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -213;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_eur[]: ind_eur[] *= z[]
 PairSumArrays(0, n_bars, z, ind_eur);
 // -------------------------------------------------------------------------
 // (v)     CovShape(EURGBP, EURJPY)
 err_code = GetPairCorrShape(0, n_bars, p_eurgbp, p_eurjpy, z); //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -214;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_eur[]: ind_eur[] *= z[]
 PairSumArrays(0, n_bars, z, ind_eur);
 // -------------------------------------------------------------------------
 // (vi)     CovShape(EURCHF, EURJPY)
 err_code = GetPairCorrShape(0, n_bars, p_eurchf, p_eurjpy, z); //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -215;
  return(err_code); 
 }                                          //  -  
 //
 // #########################################################################
 //   z[]    ind_eur[]: ind_eur[] *= z[]
 PairSumArrays(0, n_bars, z, ind_eur);
 // -------------------------------------------------------------------------
 //    EUR  " "
 err_code = NormToTrueMax(0, n_bars, ind_eur);
 // ########################### Error Definitions ###########################
 if (err_code == -7) 
 { 
  err_code = -216;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //
 // -------------------------------------------------------------------------
 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 //
 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 //
 // (3)  ""  GBP,  GBPUSD, EURGBP, GBPCHF, GBPJPY
 //
 //          EURGBP
 for (i = 0; i < n_bars; i++) 
 { 
  ind_gbp[i] = 0.0;                                            //  EURGBP
  x[i] = 1.0 / p_eurgbp[i];      //   EURGBP GBP   
 }
 // -------------------------------------------------------------------------
 // (i)     Covf(GBPUSD, GBPCHF)
 err_code = GetPairCorrShape(0, n_bars, p_gbpusd, p_gbpchf, z); //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 {
  err_code = -310;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_gbp[]: ind_gbp[] *= z[]
 PairSumArrays(0, n_bars, z, ind_gbp);
 // -------------------------------------------------------------------------
 // (ii)     CovShape(GBPUSD, GBPJPY)
 err_code = GetPairCorrShape(0, n_bars, p_gbpusd, p_gbpjpy, z); //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 {
  err_code = -311;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_gbp[]: ind_gbp[] *= z[]
 PairSumArrays(0, n_bars, z, ind_gbp);
 // -------------------------------------------------------------------------
 // (iii)     CovShape(GBPCHF, GBPJPY)
 err_code = GetPairCorrShape(0, n_bars, p_gbpchf, p_gbpjpy, z); //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 {
  err_code = -312;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_gbp[]: ind_gbp[] *= z[]
 PairSumArrays(0, n_bars, z, ind_gbp);
 // -------------------------------------------------------------------------
 // (iv)     CovShape(1/EURGBP, GBPUSD)
 err_code = GetPairCorrShape(0, n_bars, x, p_gbpusd, z);        //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -313;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_gbp[]: ind_gbp[] *= z[]
 PairSumArrays(0, n_bars, z, ind_gbp);
 // -------------------------------------------------------------------------
 // (v)     CovShape(1/EURGBP, GBPCHF)
 err_code = GetPairCorrShape(0, n_bars, x, p_gbpchf, z);        //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -314;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_gbp[]: ind_gbp[] *= z[]
 PairSumArrays(0, n_bars, z, ind_gbp);
 // -------------------------------------------------------------------------
 // (vi)     CovShape(1/EURGBP, GBPJPY)
 err_code = GetPairCorrShape(0, n_bars, x, p_gbpjpy, z);        //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -315;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_gbp[]: ind_gbp[] *= z[]
 PairSumArrays(0, n_bars, z, ind_gbp);
 // -------------------------------------------------------------------------
 //    GBP  " "
 err_code = NormToTrueMax(0, n_bars, ind_gbp);
 // ########################### Error Definitions ###########################
 if (err_code == -7) 
 { 
  err_code = -316;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //
 // -------------------------------------------------------------------------
 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 //
 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 //
 // (4)  ""  CHF,  USDCHF, EURCHF, GBPCHF, CHFJPY
 //
 //         GBPCHF, USDCHF 
 //  EURCHF
 for (i = 0; i < n_bars; i++) 
 { 
  ind_chf[i] = 0.0;                           //  GBPCHF, USDCHF  EURCHF
  x[i] = 1.0 / p_gbpchf[i];      //   GBPCHF CHF   
  y[i] = 1.0 / p_usdchf[i];      //   USDCHF CHF   
  u[i] = 1.0 / p_eurchf[i];      //   EURCHF CHF   
 }
 // -------------------------------------------------------------------------
 // (i)     Covf(1/GBPCHF, 1/USDCHF)
 err_code = GetPairCorrShape(0, n_bars, x, y, z);               //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -410;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_chf[]: ind_chf[] *= z[]
 PairSumArrays(0, n_bars, z, ind_chf);
 // -------------------------------------------------------------------------
 // (ii)     CovShape(1/GBPCHF, 1/EURCHF)
 err_code = GetPairCorrShape(0, n_bars, x, u, z);               //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -411;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_chf[]: ind_chf[] *= z[]
 PairSumArrays(0, n_bars, z, ind_chf);
 // -------------------------------------------------------------------------
 // (iii)     CovShape(1/GBPCHF, CHFJPY)
 err_code = GetPairCorrShape(0, n_bars, x, p_chfjpy, z);        //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -412;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_chf[]: ind_chf[] *= z[]
 PairSumArrays(0, n_bars, z, ind_chf);
 // -------------------------------------------------------------------------
 // (iv)     CovShape(1/USDCHF, 1/EURCHF)
 err_code = GetPairCorrShape(0, n_bars, y, u, z);               //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 {
  err_code = -413;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_chf[]: ind_chf[] *= z[]
 PairSumArrays(0, n_bars, z, ind_chf);
 // -------------------------------------------------------------------------
 // (v)     CovShape(1/USDCHF, CHFJPY)
 err_code = GetPairCorrShape(0, n_bars, y, p_chfjpy, z);        //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -414;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_chf[]: ind_chf[] *= z[]
 PairSumArrays(0, n_bars, z, ind_chf);
 // -------------------------------------------------------------------------
 // (vi)     CovShape(1/EURCHF, CHFJPY)
 err_code = GetPairCorrShape(0, n_bars, u, p_chfjpy, z);        //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -415;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_chf[]: ind_chf[] *= z[]
 PairSumArrays(0, n_bars, z, ind_chf);
 // -------------------------------------------------------------------------
 //    CHF  " "
 err_code = NormToTrueMax(0, n_bars, ind_chf);
 // ########################### Error Definitions ###########################
 if (err_code == -7) 
 { 
  err_code = -416;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //
 // -------------------------------------------------------------------------
 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 //
 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 //
 // (5)  ""  JPY,  USDJPY, EURJPY, GBPJPY, CHFJPY
 //
 //         GBPJPY, USDJPY,
 // EURJPY  CHFJPY
 for (i = 0; i < n_bars; i++) 
 { 
  ind_jpy[i] = 0.0;                   //  GBPJPY, USDJPY, EURJPY  CHFJPY
  x[i] = 1.0 / p_gbpjpy[i];      //   GBPJPY JPY   
  y[i] = 1.0 / p_usdjpy[i];      //   USDJPY JPY   
  u[i] = 1.0 / p_eurjpy[i];      //   EURJPY JPY   
  v[i] = 1.0 / p_chfjpy[i];      //   CHFJPY JPY   
 }
 // -------------------------------------------------------------------------
 // (i)     Covf(1/GBPJPY, 1/USDJPY)
 err_code = GetPairCorrShape(0, n_bars, x, y, z);               //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -510;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_jpy[]: ind_jpy[] *= z[]
 PairSumArrays(0, n_bars, z, ind_jpy);
 // -------------------------------------------------------------------------
 // (ii)     CovShape(1/GBPJPY, 1/EURJPY)
 err_code = GetPairCorrShape(0, n_bars, x, u, z);               //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -511;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_jpy[]: ind_jpy[] *= z[]
 PairSumArrays(0, n_bars, z, ind_jpy);
 // -------------------------------------------------------------------------
 // (iii)     CovShape(1/GBPJPY, 1/CHFJPY)
 err_code = GetPairCorrShape(0, n_bars, x, v, z);               //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -512;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_jpy[]: ind_jpy[] *= z[]
 PairSumArrays(0, n_bars, z, ind_jpy);
 // -------------------------------------------------------------------------
 // (iv)     CovShape(1/USDJPY, 1/EURJPY)
 err_code = GetPairCorrShape(0, n_bars, y, u, z);               //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -513;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_jpy[]: ind_jpy[] *= z[]
 PairSumArrays(0, n_bars, z, ind_jpy);
 // -------------------------------------------------------------------------
 // (v)     CovShape(1/USDJPY, 1/CHFJPY)
 err_code = GetPairCorrShape(0, n_bars, y, v, z);               //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -514;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_jpy[]: ind_jpy[] *= z[]
 PairSumArrays(0, n_bars, z, ind_jpy);
 // -------------------------------------------------------------------------
 // (vi)     CovShape(1/EURJPY, 1/CHFJPY)
 err_code = GetPairCorrShape(0, n_bars, u, v, z);               //  z[]
 f_corr  *= err_code;           //    
 // ########################### Error Definitions ###########################
 if (err_code == -8) 
 { 
  err_code = -515;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //   z[]    ind_jpy[]: ind_jpy[] *= z[]
 PairSumArrays(0, n_bars, z, ind_jpy);
 // -------------------------------------------------------------------------
 //    JPY  " "
 err_code = NormToTrueMax(0, n_bars, ind_jpy);
 // ########################### Error Definitions ###########################
 if (err_code == -7) 
 { 
  err_code = -516;
  return(err_code); 
 }                                          //  -  
 // #########################################################################
 //
 // -------------------------------------------------------------------------
 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 //
 // @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 //
 //----
 err_code = f_corr;                     //    -  f_corr
 return(err_code);
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|          |//
//|  USD, EUR, GBP, CHF, JPY         |//
//|   .    v_shift   |//
//|     ;  v_shift == 0,    |//
//|  .   10  : EURUSD,  |//
//| GBPUSD, USDCHF, USDJPY, EURGBP, EURCHF, EURJPY, GBPCHF, GBPJPY, CHFJPY|//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
double p_eurusd[];  //    EURUSD (O+H+L+C)/4
double p_gbpusd[];  //    GBPUSD (O+H+L+C)/4
double p_usdchf[];  //    USDCHF (O+H+L+C)/4
double p_usdjpy[];  //    USDJPY (O+H+L+C)/4
double p_eurgbp[];  //    EURGBP (O+H+L+C)/4
double p_eurchf[];  //    EURCHF (O+H+L+C)/4
double p_eurjpy[];  //    EURJPY (O+H+L+C)/4
double p_gbpchf[];  //    GBPCHF (O+H+L+C)/4
double p_gbpjpy[];  //    GBPJPY (O+H+L+C)/4
double p_chfjpy[];  //    CHFJPY (O+H+L+C)/4
     :
int    n_bars       //     
int    dct_on       //  : 
                    // 1 - DCT, 0 -  (5 )
double eye          //  ""
double alfa         //  
double v_shift      // " " -    \
double k_0          // " " (k_0 = 1.0 / point_s)
     : 
double err_code;    //   ; f_corr -   
     :
double idif_usd[];  //     USD
double idif_eur[];  //     EUR
double idif_gbp[];  //     GBP
double idif_chf[];  //     CHF
double idif_jpy[];  //     JPY
[double ind_usd[];  //   USD - ]
[double ind_eur[];  //   EUR - ]
[double ind_gbp[];  //   GBP - ]
[double ind_chf[];  //   CHF - ]
[double ind_jpy[];  //   JPY - ]
*/
MT4_EXPFUNC double __stdcall GetNDClusterIndexes(int n_bars, int dct_on, 
                             double eye, double alfa, double v_shift, 
                             double k_0,
                             double p_eurusd [],       double p_gbpusd [],
                             double p_usdchf [],       double p_usdjpy [],
                             double p_eurgbp [],       double p_eurchf [],
                             double p_eurjpy [],       double p_gbpchf [],
                             double p_gbpjpy [],       double p_chfjpy [],
                             double idif_usd[],        double idif_eur[],
                             double idif_gbp[],        double idif_chf[],
                                                       double idif_jpy[]
                                                      )
{
 double err_code = 0;                              //   
 double f_corr   = 0;       //      
 //
 // ########################### Error Definitions ###########################
 // *** :     ,  ***
 if (n_bars > NN_MAX)
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if (n_bars < NN_MIN)
 {  
	 err_code = -2;
	 return(err_code); 
 }
 // *** :  alfa = 0  eye <> 0,  ***
 if ((alfa == 0.0) && (eye != 0.0)) 
 {  
	 err_code = -3;
	 return(err_code); 
 }  
 // *** :  eye_size < 0,  ***
 if (eye < 0.0) 
 {  
	 err_code = -4;
	 return(err_code); 
 }  
 // *** :  eye_alfa < 0,  ***
 if (alfa < 0.0) 
 { 
	 err_code = -5;
	 return(err_code); 
 } 
 // :      , 
 if (v_shift > VB_MAX)
 {  
	 err_code = -10;
	 return(err_code); 
 } 
 // :      , 
 if (v_shift < VB_MIN)
 {  
	 err_code = -11;
	 return(err_code); 
 } 
 // #########################################################################
 //
 //----
 //  ""     USD, EUR, GBP, CHF, JPY
 err_code = GetRawClusterIndexes(n_bars, dct_on, eye, alfa, p_eurusd, p_gbpusd, 
                                                            p_usdchf, p_usdjpy,
                                                            p_eurgbp, p_eurchf,
                                                            p_eurjpy, p_gbpchf,
                                                            p_gbpjpy, p_chfjpy,
                                                            ind_usd,  ind_eur,
                                                            ind_gbp,  ind_chf, 
                                                                      ind_jpy);
 //
 if (err_code < 0) { return(err_code); }        //    - 
 f_corr = err_code;            //    
 // -------------------------------------------------------------------------
 // --------------------------------- EUR -----------------------------------
 if (v_shift == 0.0)               //   v_shift   
 {
  //  ""   EUR
  err_code = GetFirstDeriv(0, n_bars, k_0, ind_eur, idif_eur);
 }
 else                           //   v_shift    
 {
  //         v_shift
  err_code = GetTaylorSum(0, n_bars, v_shift, k_0, ind_eur, idif_eur);
 }
 //    EUR  " "
 err_code = NormToTrueMax(0, n_bars, idif_eur);
 // -------------------------------------------------------------------------
 // --------------------------------- USD -----------------------------------
 if (v_shift == 0.0)               //   v_shift   
 {
  //  ""   USD 
  err_code = GetFirstDeriv(0, n_bars, k_0, ind_usd, idif_usd);
 }
 else                           //   v_shift    
 {
  //         v_shift
  err_code = GetTaylorSum(0, n_bars, v_shift, k_0, ind_usd, idif_usd);
 }
 //    USD  " "
 err_code = NormToTrueMax(0, n_bars, idif_usd);
 // -------------------------------------------------------------------------
 // --------------------------------- GBP -----------------------------------
 if (v_shift == 0.0)               //   v_shift   
 {
  //  ""   GBP
  err_code = GetFirstDeriv(0, n_bars, k_0, ind_gbp, idif_gbp);
 }
 else                           //   v_shift    
 {
  //         v_shift
  err_code = GetTaylorSum(0, n_bars, v_shift, k_0, ind_gbp, idif_gbp);
 }
 //    GBP  " "
 err_code = NormToTrueMax(0, n_bars, idif_gbp);
 // -------------------------------------------------------------------------
 // --------------------------------- CHF -----------------------------------
 if (v_shift == 0.0)               //   v_shift   
 {
  //  ""   CHF
  err_code = GetFirstDeriv(0, n_bars, k_0, ind_chf, idif_chf);
 }
 else                           //   v_shift    
 {
  //         v_shift
  err_code = GetTaylorSum(0, n_bars, v_shift, k_0, ind_chf, idif_chf);
 }
 //    CHF  " "
 err_code = NormToTrueMax(0, n_bars, idif_chf);
 // -------------------------------------------------------------------------
 // --------------------------------- JPY -----------------------------------
 if (v_shift == 0.0)               //   v_shift   
 {
  //  ""   JPY
  err_code = GetFirstDeriv(0, n_bars, k_0, ind_jpy, idif_jpy);
 }
 else                           //   v_shift    
 {
  //         v_shift
  err_code = GetTaylorSum(0, n_bars, v_shift, k_0, ind_jpy, idif_jpy);
 }
 //    JPY  " "
 err_code = NormToTrueMax(0, n_bars, idif_jpy);
 // -------------------------------------------------------------------------
 //----
 if (err_code > 0) { err_code = f_corr; }
 return(err_code);     //   ; f_corr -    
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|       NOMDEN; |//
//| NOM -       ,            |//
//| DEN -                  |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
double p_eurusd[];  //    EURUSD (O+H+L+C)/4
double p_gbpusd[];  //    GBPUSD (O+H+L+C)/4
double p_usdchf[];  //    USDCHF (O+H+L+C)/4
double p_usdjpy[];  //    USDJPY (O+H+L+C)/4
double p_eurgbp[];  //    EURGBP (O+H+L+C)/4
double p_eurchf[];  //    EURCHF (O+H+L+C)/4
double p_eurjpy[];  //    EURJPY (O+H+L+C)/4
double p_gbpchf[];  //    GBPCHF (O+H+L+C)/4
double p_gbpjpy[];  //    GBPJPY (O+H+L+C)/4
double p_chfjpy[];  //    CHFJPY (O+H+L+C)/4
     :
int    p_num        //    
int    n_bars       //     
int    dct_on       //  : 
                    // 1 - DCT, 0 -  (5 )
double eye          //  ""
double alfa         //  
double v_shift      // " " -    \
double k_0          // " " (k_0 = 1.0 / point_s)
     : 
double err_code;       //   ; f_corr -   
     :
double idif_n[];    //     - 
double idif_d[];    //     - 
double idif_p[];    //    
double idif_q[];    // (idif_usd ^ 2 + idif_eur ^ 2 + 
                    //  idif_gbp ^ 2 + idif_chf ^ 2 + idif_jpy ^ 2) / 5.0
[double x[];        //    - ]
[double ind_usd[];  //   USD - ]
[double ind_eur[];  //   EUR - ]
[double ind_gbp[];  //   GBP - ]
[double ind_chf[];  //   CHF - ]
[double ind_jpy[];  //   JPY - ]
[double idif_usd[]  //    USD - ]
[double idif_eur[]  //    EUR - ]
[double idif_gbp[]  //    GBP - ]
[double idif_chf[]  //    CHF - ]
[double idif_jpy[]  //    JPY - ]
*/
MT4_EXPFUNC double __stdcall GetNormDiffIndexPair(
                             int    p_num,  int n_bars, int dct_on, 
                             double eye, double alfa, double v_shift, 
                             double k_0, 
                             double p_eurusd [],    double p_gbpusd [],
                             double p_usdchf [],    double p_usdjpy [],
                             double p_eurgbp [],    double p_eurchf [],
                             double p_eurjpy [],    double p_gbpchf [],
                             double p_gbpjpy [],    double p_chfjpy [],
                             double idif_p   [],    double idif_n   [],
                             double idif_d   [],    double idif_q   []
                                                    )
{
 double err_code = 0;                              //   
 double f_corr   = 0;       //      
 double sum      = 0;                                           // 
 int    i;                                              //   
 //
 // ########################### Error Definitions ###########################
 // *** :     ,  ***
 if (n_bars > NN_MAX)
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if (n_bars < NN_MIN)
 {  
	 err_code = -2;
	 return(err_code); 
 }
 // *** :  alfa = 0  eye <> 0,  ***
 if ((alfa == 0.0) && (eye != 0.0)) 
 {  
	 err_code = -3;
	 return(err_code); 
 }  
 // *** :  eye_size < 0,  ***
 if (eye < 0.0) 
 {  
	 err_code = -4;
	 return(err_code); 
 }  
 // *** :  eye_alfa < 0,  ***
 if (alfa < 0.0) 
 { 
	 err_code = -5;
	 return(err_code); 
 } 
 // :      , 
 if (v_shift > VB_MAX)
 {  
	 err_code = -10;
	 return(err_code); 
 } 
 // :      , 
 if (v_shift < VB_MIN)
 {  
	 err_code = -11;
	 return(err_code); 
 }
 // :     , 
 if ((p_num < 1) || (p_num > 10))
 {
  err_code = -12;
  return(err_code);
 }
 // #########################################################################
 //  ""     
 err_code = GetNDClusterIndexes(n_bars, dct_on, eye, alfa, v_shift, k_0,
                                p_eurusd, p_gbpusd, p_usdchf, p_usdjpy,
                                p_eurgbp, p_eurchf, p_eurjpy, p_gbpchf,
                                p_gbpjpy, p_chfjpy, idif_usd, idif_eur,
                                idif_gbp, idif_chf, idif_jpy);
 if (err_code < 0) { return(err_code); }        //    - 
 f_corr = err_code;            //    
 // 
 // -1- EURUSD --------------------------------------------------------------
 if (p_num == 1)
 {
  //    EURUSD,     x[]
  for (i = 0; i < n_bars; i++) { x[i] = ind_eur[i] / ind_usd[i]; }
  //    EURUSD      
  if (v_shift == 0.0)              //   v_shift   
  {
   //    EURUSD,     idif_p[]
   err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
  }
  else                          //   v_shift    
  {
   //         v_shift
   err_code = GetTaylorSum(0, n_bars, v_shift, k_0, x, idif_p);
  }
  //    EURUSD  " "
  err_code = NormToTrueMax(0, n_bars, idif_p);
  //   idif_q[], idif_n[]  idif_d[]
  for (i = 0; i < n_bars; i++) 
  {
   sum  = 0;
   sum  = idif_usd[i] * idif_usd[i]; sum += idif_eur[i] * idif_eur[i];
   sum += idif_gbp[i] * idif_gbp[i]; sum += idif_chf[i] * idif_chf[i];
   sum += idif_jpy[i] * idif_jpy[i]; 
   idif_q[i] = (sum / 5.0);
   idif_n[i] = idif_eur[i]; 
   idif_d[i] = idif_usd[i];
  }
  if (err_code > 0) { err_code = f_corr; }
  return(err_code);    //   ; f_corr -    
 }
 //
 // -2- GBPUSD --------------------------------------------------------------
 if (p_num == 2)
 {
  //    GBPUSD,     x[]
  for (i = 0; i < n_bars; i++) { x[i] = ind_gbp[i] / ind_usd[i]; }
  //    EURUSD      
  if (v_shift == 0.0)              //   v_shift   
  {
   //    GBPUSD,     idif_p[]
   err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
  }
  else                          //   v_shift    
  {
   //         v_shift
   err_code = GetTaylorSum(0, n_bars, v_shift, k_0, x, idif_p);
  }
  //    GBPUSD  " "
  err_code = NormToTrueMax(0, n_bars, idif_p);
  //   idif_q[], idif_n[]  idif_d[]
  for (i = 0; i < n_bars; i++) 
  {
   sum  = 0;
   sum  = idif_usd[i] * idif_usd[i]; sum += idif_eur[i] * idif_eur[i];
   sum += idif_gbp[i] * idif_gbp[i]; sum += idif_chf[i] * idif_chf[i];
   sum += idif_jpy[i] * idif_jpy[i]; 
   idif_q[i] = (sum / 5.0);
   idif_n[i] = idif_gbp[i]; 
   idif_d[i] = idif_usd[i];
  }
  if (err_code > 0) { err_code = f_corr; }
  return(err_code);    //   ; f_corr -    
 }
 //
 // -3- USDCHF --------------------------------------------------------------
 if (p_num == 3)
 {
  //    USDCHF,     x[]
  for (i = 0; i < n_bars; i++) { x[i] = ind_usd[i] / ind_chf[i]; }
  //    USDCHF      
  if (v_shift == 0.0)              //   v_shift   
  {
   //    USDCHF,     idif_p[]
   err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
  }
  else                          //   v_shift    
  {
   //         v_shift
   err_code = GetTaylorSum(0, n_bars, v_shift, k_0, x, idif_p);
  }
  //    USDCHF  " "
  err_code = NormToTrueMax(0, n_bars, idif_p);
  //   idif_q[], idif_n[]  idif_d[]
  for (i = 0; i < n_bars; i++) 
  {
   sum  = 0;
   sum  = idif_usd[i] * idif_usd[i]; sum += idif_eur[i] * idif_eur[i];
   sum += idif_gbp[i] * idif_gbp[i]; sum += idif_chf[i] * idif_chf[i];
   sum += idif_jpy[i] * idif_jpy[i]; 
   idif_q[i] = (sum / 5.0);
   idif_n[i] = idif_usd[i];
   idif_d[i] = idif_chf[i];
  }
  if (err_code > 0) { err_code = f_corr; }
  return(err_code);    //   ; f_corr -    
 }
 //
 // -4- USDJPY --------------------------------------------------------------
 if (p_num == 4)
 {
  //    USDJPY,     x[]
  for (i = 0; i < n_bars; i++) { x[i] = ind_usd[i] / ind_jpy[i]; }
  //    USDJPY      
  if (v_shift == 0.0)              //   v_shift   
  {
   //    USDJPY,     idif_p[]
   err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
  }
  else                          //   v_shift    
  {
   //         v_shift
   err_code = GetTaylorSum(0, n_bars, v_shift, k_0, x, idif_p);
  }
  //    USDJPY  " "
  err_code = NormToTrueMax(0, n_bars, idif_p);
  //   idif_q[], idif_n[]  idif_d[]
  for (i = 0; i < n_bars; i++) 
  {
   sum  = 0;
   sum  = idif_usd[i] * idif_usd[i]; sum += idif_eur[i] * idif_eur[i];
   sum += idif_gbp[i] * idif_gbp[i]; sum += idif_chf[i] * idif_chf[i];
   sum += idif_jpy[i] * idif_jpy[i]; 
   idif_q[i] = (sum / 5.0);
   idif_n[i] = idif_usd[i]; 
   idif_d[i] = idif_jpy[i];
  }
  if (err_code > 0) { err_code = f_corr; }
  return(err_code);    //   ; f_corr -    
 }
 //
 // -5- EURGBP --------------------------------------------------------------
 if (p_num == 5)
 {
  //    EURGBP,     x[]
  for (i = 0; i < n_bars; i++) { x[i] = ind_eur[i] / ind_gbp[i]; }
  //    EURGBP      
  if (v_shift == 0.0)              //   v_shift   
  {
   //    EURGBP,     idif_p[]
   err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
  }
  else                          //   v_shift    
  {
   //         v_shift
   err_code = GetTaylorSum(0, n_bars, v_shift, k_0, x, idif_p);
  }
  //    EURGBP  " "
  err_code = NormToTrueMax(0, n_bars, idif_p);
  //   idif_q[], idif_n[]  idif_d[]
  for (i = 0; i < n_bars; i++) 
  {
   sum  = 0;
   sum  = idif_usd[i] * idif_usd[i]; sum += idif_eur[i] * idif_eur[i];
   sum += idif_gbp[i] * idif_gbp[i]; sum += idif_chf[i] * idif_chf[i];
   sum += idif_jpy[i] * idif_jpy[i]; 
   idif_q[i] = (sum / 5.0);
   idif_n[i] = idif_eur[i]; 
   idif_d[i] = idif_gbp[i];
  }
  if (err_code > 0) { err_code = f_corr; }
  return(err_code);    //   ; f_corr -    
 }
 //
 // -6- EURCHF --------------------------------------------------------------
 if (p_num == 6)
 {
  //    EURCHF,     x[]
  for (i = 0; i < n_bars; i++) { x[i] = ind_eur[i] / ind_chf[i]; }
  //    EURCHF      
  if (v_shift == 0.0)              //   v_shift   
  {
   //    EURCHF,     idif_p[]
   err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
  }
  else                          //   v_shift    
  {
   //         v_shift
   err_code = GetTaylorSum(0, n_bars, v_shift, k_0, x, idif_p);
  }
  //    EURCHF  " "
  err_code = NormToTrueMax(0, n_bars, idif_p);
  //   idif_q[], idif_n[]  idif_d[]
  for (i = 0; i < n_bars; i++) 
  {
   sum  = 0;
   sum  = idif_usd[i] * idif_usd[i]; sum += idif_eur[i] * idif_eur[i];
   sum += idif_gbp[i] * idif_gbp[i]; sum += idif_chf[i] * idif_chf[i];
   sum += idif_jpy[i] * idif_jpy[i]; 
   idif_q[i] = (sum / 5.0);
   idif_n[i] = idif_eur[i]; 
   idif_d[i] = idif_chf[i];
  }
  if (err_code > 0) { err_code = f_corr; }
  return(err_code);    //   ; f_corr -    
 }
 //
 // -7- EURJPY --------------------------------------------------------------
 if (p_num == 7)
 {
  //    EURJPY,     x[]
  for (i = 0; i < n_bars; i++) { x[i] = ind_eur[i] / ind_jpy[i]; }
  //    EURJPY      
  if (v_shift == 0.0)              //   v_shift   
  {
   //    EURJPY,     idif_p[]
   err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
  }
  else                          //   v_shift    
  {
   //         v_shift
   err_code = GetTaylorSum(0, n_bars, v_shift, k_0, x, idif_p);
  }
  //    EURJPY  " "
  err_code = NormToTrueMax(0, n_bars, idif_p);
  //   idif_q[], idif_n[]  idif_d[]
  for (i = 0; i < n_bars; i++) 
  {
   sum  = 0;
   sum  = idif_usd[i] * idif_usd[i]; sum += idif_eur[i] * idif_eur[i];
   sum += idif_gbp[i] * idif_gbp[i]; sum += idif_chf[i] * idif_chf[i];
   sum += idif_jpy[i] * idif_jpy[i]; 
   idif_q[i] = (sum / 5.0);
   idif_n[i] = idif_eur[i]; 
   idif_d[i] = idif_jpy[i];
  }
  if (err_code > 0) { err_code = f_corr; }
  return(err_code);    //   ; f_corr -    
 }
 //
 // -8- GBPCHF --------------------------------------------------------------
 if (p_num == 8)
 {
  //    GBPCHF,     x[]
  for (i = 0; i < n_bars; i++) { x[i] = ind_gbp[i] / ind_chf[i]; }
  //    GBPCHF      
  if (v_shift == 0.0)              //   v_shift   
  {
   //    GBPCHF,     idif_p[]
   err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
  }
  else                          //   v_shift    
  {
   //         v_shift
   err_code = GetTaylorSum(0, n_bars, v_shift, k_0, x, idif_p);
  }
  //    GBPCHF  " "
  err_code = NormToTrueMax(0, n_bars, idif_p);
  //   idif_q[], idif_n[]  idif_d[]
  for (i = 0; i < n_bars; i++) 
  {
   sum  = 0;
   sum  = idif_usd[i] * idif_usd[i]; sum += idif_eur[i] * idif_eur[i];
   sum += idif_gbp[i] * idif_gbp[i]; sum += idif_chf[i] * idif_chf[i];
   sum += idif_jpy[i] * idif_jpy[i]; 
   idif_q[i] = (sum / 5.0);
   idif_n[i] = idif_gbp[i]; 
   idif_d[i] = idif_chf[i];
  }
  if (err_code > 0) { err_code = f_corr; }
  return(err_code);    //   ; f_corr -    
 }
 //
 // -9- GBPJPY --------------------------------------------------------------
 if (p_num == 9)
 {
  //    GBPJPY,     x[]
  for (i = 0; i < n_bars; i++) { x[i] = ind_gbp[i] / ind_jpy[i]; }
  //    GBPJPY      
  if (v_shift == 0.0)              //   v_shift   
  {
   //    GBPJPY,     idif_p[]
   err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
  }
  else                          //   v_shift    
  {
   //         v_shift
   err_code = GetTaylorSum(0, n_bars, v_shift, k_0, x, idif_p);
  }
  //    GBPJPY  " "
  err_code = NormToTrueMax(0, n_bars, idif_p);
  //   idif_q[], idif_n[]  idif_d[]
  for (i = 0; i < n_bars; i++) 
  {
   sum  = 0;
   sum  = idif_usd[i] * idif_usd[i]; sum += idif_eur[i] * idif_eur[i];
   sum += idif_gbp[i] * idif_gbp[i]; sum += idif_chf[i] * idif_chf[i];
   sum += idif_jpy[i] * idif_jpy[i]; 
   idif_q[i] = (sum / 5.0);
   idif_n[i] = idif_gbp[i]; 
   idif_d[i] = idif_jpy[i];
  }
  if (err_code > 0) { err_code = f_corr; }
  return(err_code);    //   ; f_corr -    
 }
 //
 // -10- CHFJPY -------------------------------------------------------------
 if (p_num == 10)
 {
  //    CHFJPY,     x[]
  for (i = 0; i < n_bars; i++) { x[i] = ind_chf[i] / ind_jpy[i]; }
  //    GBPJPY      
  if (v_shift == 0.0)              //   v_shift   
  {
   //    CHFJPY,     idif_p[]
   err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
  }
  else                          //   v_shift    
  {
   //         v_shift
   err_code = GetTaylorSum(0, n_bars, v_shift, k_0, x, idif_p);
  }
  //    CHFJPY  " "
  err_code = NormToTrueMax(0, n_bars, idif_p);
  //   idif_q[], idif_n[]  idif_d[]
  for (i = 0; i < n_bars; i++) 
  {
   sum  = 0;
   sum  = idif_usd[i] * idif_usd[i]; sum += idif_eur[i] * idif_eur[i];
   sum += idif_gbp[i] * idif_gbp[i]; sum += idif_chf[i] * idif_chf[i];
   sum += idif_jpy[i] * idif_jpy[i]; 
   idif_q[i] = (sum / 5.0);
   idif_n[i] = idif_chf[i]; 
   idif_d[i] = idif_jpy[i];
  }
  if (err_code > 0) { err_code = f_corr; }
  return(err_code);    //   ; f_corr -    
 }
 //----
 if (err_code > 0) { err_code = f_corr; }
 return(err_code);     //   ; f_corr -    
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//|    -    NOMDEN;              |//
//| NOM -       ,            |//
//| DEN -                  |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
double p_eurusd[];  //    EURUSD (O+H+L+C)/4
double p_gbpusd[];  //    GBPUSD (O+H+L+C)/4
double p_usdchf[];  //    USDCHF (O+H+L+C)/4
double p_usdjpy[];  //    USDJPY (O+H+L+C)/4
double p_eurgbp[];  //    EURGBP (O+H+L+C)/4
double p_eurchf[];  //    EURCHF (O+H+L+C)/4
double p_eurjpy[];  //    EURJPY (O+H+L+C)/4
double p_gbpchf[];  //    GBPCHF (O+H+L+C)/4
double p_gbpjpy[];  //    GBPJPY (O+H+L+C)/4
double p_chfjpy[];  //    CHFJPY (O+H+L+C)/4
     :
int    p_num        //    
int    n_bars       //     
int    dct_on       //  : 
                    // 1 - DCT, 0 -  (5 )
double eye          //  ""
double alfa         //  
double v_shift      // " " -    \
double k_0          // " " (k_0 = 1.0 / point_s)
double reg          //     1/arg
     : 
double err_code;    //   ; f_corr -   
     :
double idif_n[];    //     - 
double idif_d[];    //     - 
double idif_p[];    //    
[double idif_q[];   // (idif_usd ^ 2 + idif_eur ^ 2 + idif_gbp ^ 2 + 
                    //  idif_chf ^ 2 + idif_jpy ^ 2) / 5.0 - ]
[double ind_usd[];  //   USD - ]
[double ind_eur[];  //   EUR - ]
[double ind_gbp[];  //   GBP - ]
[double ind_chf[];  //   CHF - ]
[double ind_jpy[];  //   JPY - ]
[double idif_usd[]  //    USD - ]
[double idif_eur[]  //    EUR - ]
[double idif_gbp[]  //    GBP - ]
[double idif_chf[]  //    CHF - ]
[double idif_jpy[]  //    JPY - ]
*/
MT4_EXPFUNC double __stdcall GetNDIRHTSignals(int p_num, int n_bars, 
                             int dct_on, double eye, double alfa, 
                             double v_shift, double k_0, double reg,
                             double p_eurusd [],    double p_gbpusd [],
                             double p_usdchf [],    double p_usdjpy [],
                             double p_eurgbp [],    double p_eurchf [],
                             double p_eurjpy [],    double p_gbpchf [],
                             double p_gbpjpy [],    double p_chfjpy [],
                             double idif_p   [],    double idif_n   [],
                                                    double idif_d   []
                                                    )
{
 double err_code = 0;                              //   
 double f_corr   = 0;       //      
 double tmp      = 0;                                 //  
 int    i;                                              //   
 //
 // ########################### Error Definitions ###########################
 // *** :     ,  ***
 if (n_bars > NN_MAX)
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if (n_bars < NN_MIN)
 {  
	 err_code = -2;
	 return(err_code); 
 }
 // *** :  alfa = 0  eye <> 0,  ***
 if ((alfa == 0.0) && (eye != 0.0)) 
 {  
	 err_code = -3;
	 return(err_code); 
 }  
 // *** :  eye_size < 0,  ***
 if (eye < 0.0) 
 {  
	 err_code = -4;
	 return(err_code); 
 }  
 // *** :  eye_alfa < 0,  ***
 if (alfa < 0.0) 
 { 
	 err_code = -5;
	 return(err_code); 
 } 
 // :      , 
 if (v_shift > VB_MAX)
 {  
	 err_code = -10;
	 return(err_code); 
 } 
 // :      , 
 if (v_shift < VB_MIN)
 {  
	 err_code = -11;
	 return(err_code); 
 }
 // :     , 
 if ((p_num < 1) || (p_num > 10))
 {
  err_code = -12;
  return(err_code);
 }
 // :      , 
 if (reg < EPS)
 {
  err_code = -13;
  return(err_code);
 }
 // #########################################################################
 //----
 //      NOMDEN
 //   
 err_code = GetNormDiffIndexPair(p_num, n_bars, dct_on, 
                                 eye, alfa, v_shift, k_0,
                                 p_eurusd, p_gbpusd, p_usdchf, p_usdjpy,
                                 p_eurgbp, p_eurchf, p_eurjpy, p_gbpchf,
                                 p_gbpjpy, p_chfjpy, idif_p, idif_n,
                                                     idif_d, idif_q);
 if (err_code < 0) { return(err_code); }        //    - 
 f_corr = err_code;            //    
 //
 //   idif_p[]  idif_q[]
 for (i = 0; i < n_bars; i++) { idif_p[i] *= idif_q[i]; }
 //     idif_p[]
 for (i = 0; i < n_bars; i++)
 { tmp = idif_p[i]; idif_p[i] = tmp / (tmp * tmp + reg); }
 //     idif_p[]
 err_code = NormToHypTan(0, n_bars, idif_p);
 //
 //   idif_n[]  idif_q[]
 for (i = 0; i < n_bars; i++) { idif_n[i] *= idif_q[i]; }
 //     idif_n[]
 for (i = 0; i < n_bars; i++)
 { tmp = idif_n[i]; idif_n[i] = tmp / (tmp * tmp + reg); }
 //     idif_n[]
 err_code = NormToHypTan(0, n_bars, idif_n);
 //
 //   idif_d[]  idif_q[]
 for (i = 0; i < n_bars; i++) { idif_d[i] *= idif_q[i]; }
 //     idif_d[]
 for (i = 0; i < n_bars; i++)
 { tmp = idif_d[i]; idif_d[i] = tmp / (tmp * tmp + reg); }
 //     idif_d[]
 err_code = NormToHypTan(0, n_bars, idif_d);
 //----
 if (err_code > 0) { err_code = f_corr; }
 return(err_code);     //   ; f_corr -    
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//| 1.      EURUSD         |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
double p_eurusd[];  //    EURUSD (O+H+L+C)/4
double p_gbpusd[];  //    GBPUSD (O+H+L+C)/4
double p_usdchf[];  //    USDCHF (O+H+L+C)/4
double p_usdjpy[];  //    USDJPY (O+H+L+C)/4
double p_eurgbp[];  //    EURGBP (O+H+L+C)/4
double p_eurchf[];  //    EURCHF (O+H+L+C)/4
double p_eurjpy[];  //    EURJPY (O+H+L+C)/4
double p_gbpchf[];  //    GBPCHF (O+H+L+C)/4
double p_gbpjpy[];  //    GBPJPY (O+H+L+C)/4
double p_chfjpy[];  //    CHFJPY (O+H+L+C)/4
     :
int    n_bars       //     
int    dct_on       //  : 
                    // 1 - DCT, 0 -  (5 )
double eye          //  ""
double alfa         //  
double k_0          // " " (k_0 = 1.0 / point_s)
     : 
double err_code;    //   ; f_corr -   
     :
double idif_eur[];  //    - 
double idif_usd[];  //    - 
double idif_p[];    //     EURUSD
[double x[]         //    EURUSD - ]
[double ind_usd[];  //   USD - ]
[double ind_eur[];  //   EUR - ]
[double ind_gbp[];  //   GBP - ]
[double ind_chf[];  //   CHF - ]
[double ind_jpy[];  //   JPY - ]
*/
MT4_EXPFUNC double __stdcall GetNormDiffIndexEURUSD(int n_bars, int dct_on,
                                                    double eye, 
                             double alfa,           double k_0,
                             double p_eurusd [],    double p_gbpusd [],
                             double p_usdchf [],    double p_usdjpy [],
                             double p_eurgbp [],    double p_eurchf [],
                             double p_eurjpy [],    double p_gbpchf [],
                             double p_gbpjpy [],    double p_chfjpy [],
                             double idif_eur[],     double idif_usd[],
                                                    double idif_p  []
                                                   )
{
 double err_code = 0;                              //   
 double f_corr   = 0;       //      
 int i;                                                 //   
 //
 // ########################### Error Definitions ###########################
 // *** :     ,  ***
 if (n_bars > NN_MAX)
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if (n_bars < NN_MIN)
 {  
	 err_code = -2;
	 return(err_code); 
 }
 // *** :  alfa = 0  eye <> 0,  ***
 if ((alfa == 0.0) && (eye != 0.0)) 
 {  
	 err_code = -3;
	 return(err_code); 
 }  
 // *** :  eye_size < 0,  ***
 if (eye < 0.0) 
 {  
	 err_code = -4;
	 return(err_code); 
 }  
 // *** :  eye_alfa < 0,  ***
 if (alfa < 0.0) 
 { 
	 err_code = -5;
	 return(err_code); 
 }    
 // #########################################################################
 //
 //----
 //  ""     USD, EUR, GBP, CHF, JPY
 err_code = GetRawClusterIndexes(n_bars, dct_on, eye, alfa, p_eurusd, p_gbpusd, 
                                                            p_usdchf, p_usdjpy,
                                                            p_eurgbp, p_eurchf,
                                                            p_eurjpy, p_gbpchf,
                                                            p_gbpjpy, p_chfjpy,
                                                            ind_usd,  ind_eur,
                                                            ind_gbp,  ind_chf, 
                                                                      ind_jpy);
 if (err_code < 0) { return(err_code); }        //    - 
 f_corr = err_code;            //    
 //   ""   EUR ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_eur, idif_eur);
 //    EUR  " "
 err_code = NormToTrueMax(0, n_bars, idif_eur);
 //  ""   USD ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_usd, idif_usd);
 //    USD  " "
 err_code = NormToTrueMax(0, n_bars, idif_usd);
 //    EURUSD,     x[]
 for (i = 0; i < n_bars; i++) { x[i] = ind_eur[i] / ind_usd[i]; }
 //    EURUSD
 err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
 //    EURUSD  " "
 err_code = NormToTrueMax(0, n_bars, idif_p);
 //----
 if (err_code > 0) { err_code = f_corr; }
 return(err_code);     //   ; f_corr -    
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//| 2.      GBPUSD        |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
double p_eurusd[];  //    EURUSD (O+H+L+C)/4
double p_gbpusd[];  //    GBPUSD (O+H+L+C)/4
double p_usdchf[];  //    USDCHF (O+H+L+C)/4
double p_usdjpy[];  //    USDJPY (O+H+L+C)/4
double p_eurgbp[];  //    EURGBP (O+H+L+C)/4
double p_eurchf[];  //    EURCHF (O+H+L+C)/4
double p_eurjpy[];  //    EURJPY (O+H+L+C)/4
double p_gbpchf[];  //    GBPCHF (O+H+L+C)/4
double p_gbpjpy[];  //    GBPJPY (O+H+L+C)/4
double p_chfjpy[];  //    CHFJPY (O+H+L+C)/4
     :
int    n_bars       //     
int    dct_on       //  : 
                    // 1 - DCT, 0 -  (5 )
double eye          //  ""
double alfa         //  
double k_0          // " " (k_0 = 1.0 / point_s)
     : 
double err_code;    //   ; f_corr -   
     :
double idif_gbp[];  //    - 
double idif_usd[];  //    - 
double idif_p[];    //     GBPUSD
[double x[]         //    GBPUSD - ]
[double ind_usd[];  //   USD - ]
[double ind_eur[];  //   EUR - ]
[double ind_gbp[];  //   GBP - ]
[double ind_chf[];  //   CHF - ]
[double ind_jpy[];  //   JPY - ]
*/
MT4_EXPFUNC double __stdcall GetNormDiffIndexGBPUSD(int n_bars, int dct_on,
                                                    double eye, 
                             double alfa,           double k_0,
                             double p_eurusd [],    double p_gbpusd [],
                             double p_usdchf [],    double p_usdjpy [],
                             double p_eurgbp [],    double p_eurchf [],
                             double p_eurjpy [],    double p_gbpchf [],
                             double p_gbpjpy [],    double p_chfjpy [],
                             double idif_gbp[],     double idif_usd[],
                                                    double idif_p  []
                                                   )
{
 double err_code = 0;                              //   
 double f_corr   = 0;       //      
 int i;                                                 //   
 //
 // ########################### Error Definitions ###########################
 // *** :     ,  ***
 if (n_bars > NN_MAX)
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if (n_bars < NN_MIN)
 {  
	 err_code = -2;
	 return(err_code); 
 }
 // *** :  alfa = 0  eye <> 0,  ***
 if ((alfa == 0.0) && (eye != 0.0)) 
 {  
	 err_code = -3;
	 return(err_code); 
 }  
 // *** :  eye_size < 0,  ***
 if (eye < 0.0) 
 {  
	 err_code = -4;
	 return(err_code); 
 }  
 // *** :  eye_alfa < 0,  ***
 if (alfa < 0.0) 
 { 
	 err_code = -5;
	 return(err_code); 
 }    
 // #########################################################################
 //
 //----
 //  ""     USD, EUR, GBP, CHF, JPY
 err_code = GetRawClusterIndexes(n_bars, dct_on, eye, alfa, p_eurusd, p_gbpusd, 
                                                            p_usdchf, p_usdjpy,
                                                            p_eurgbp, p_eurchf,
                                                            p_eurjpy, p_gbpchf,
                                                            p_gbpjpy, p_chfjpy,
                                                            ind_usd,  ind_eur,
                                                            ind_gbp,  ind_chf, 
                                                                      ind_jpy);
 if (err_code < 0) { return(err_code); }        //    - 
 f_corr = err_code;       //    
 //   ""   GBP ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_gbp, idif_gbp);
 //    GBP  " "
 err_code = NormToTrueMax(0, n_bars, idif_gbp);
 //  ""   USD ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_usd, idif_usd);
 //    USD  " "
 err_code = NormToTrueMax(0, n_bars, idif_usd);
 //    GBPUSD,     x[]
 for (i = 0; i < n_bars; i++) { x[i] = ind_gbp[i] / ind_usd[i]; }
 //    GBPUSD
 err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
 //    GBPUSD  " "
 err_code = NormToTrueMax(0, n_bars, idif_p);
 //----
 if (err_code > 0) { err_code = f_corr; }
 return(err_code);     //   ; f_corr -    
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//| 3.      USDCHF        |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
double p_eurusd[];  //    EURUSD (O+H+L+C)/4
double p_gbpusd[];  //    GBPUSD (O+H+L+C)/4
double p_usdchf[];  //    USDCHF (O+H+L+C)/4
double p_usdjpy[];  //    USDJPY (O+H+L+C)/4
double p_eurgbp[];  //    EURGBP (O+H+L+C)/4
double p_eurchf[];  //    EURCHF (O+H+L+C)/4
double p_eurjpy[];  //    EURJPY (O+H+L+C)/4
double p_gbpchf[];  //    GBPCHF (O+H+L+C)/4
double p_gbpjpy[];  //    GBPJPY (O+H+L+C)/4
double p_chfjpy[];  //    CHFJPY (O+H+L+C)/4
     :
int    n_bars       //     
int    dct_on       //  : 
                    // 1 - DCT, 0 -  (5 )
double eye          //  ""
double alfa         //  
double k_0          // " " (k_0 = 1.0 / point_s)
     : 
double err_code;    //   ; f_corr -   
     :
double idif_usd[];  //    - 
double idif_chf[];  //    - 
double idif_p[];    //     USDCHF
[double x[]         //    USDCHF - ]
[double ind_usd[];  //   USD - ]
[double ind_eur[];  //   EUR - ]
[double ind_gbp[];  //   GBP - ]
[double ind_chf[];  //   CHF - ]
[double ind_jpy[];  //   JPY - ]
*/
MT4_EXPFUNC double __stdcall GetNormDiffIndexUSDCHF(int n_bars, int dct_on,
                                                    double eye, 
                             double alfa,           double k_0,
                             double p_eurusd [],    double p_gbpusd [],
                             double p_usdchf [],    double p_usdjpy [],
                             double p_eurgbp [],    double p_eurchf [],
                             double p_eurjpy [],    double p_gbpchf [],
                             double p_gbpjpy [],    double p_chfjpy [],
                             double idif_usd[],     double idif_chf[],
                                                    double idif_p  []
                                                   )
{
 double err_code = 0;                              //   
 double f_corr   = 0;       //      
 int i;                                                 //   
 //
 // ########################### Error Definitions ###########################
 // *** :     ,  ***
 if (n_bars > NN_MAX)
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if (n_bars < NN_MIN)
 {  
	 err_code = -2;
	 return(err_code); 
 }
 // *** :  alfa = 0  eye <> 0,  ***
 if ((alfa == 0.0) && (eye != 0.0)) 
 {  
	 err_code = -3;
	 return(err_code); 
 }  
 // *** :  eye_size < 0,  ***
 if (eye < 0.0) 
 {  
	 err_code = -4;
	 return(err_code); 
 }  
 // *** :  eye_alfa < 0,  ***
 if (alfa < 0.0) 
 { 
	 err_code = -5;
	 return(err_code); 
 }    
 // #########################################################################
 //
 //----
 //  ""     USD, EUR, GBP, CHF, JPY
 err_code = GetRawClusterIndexes(n_bars, dct_on, eye, alfa, p_eurusd, p_gbpusd, 
                                                            p_usdchf, p_usdjpy,
                                                            p_eurgbp, p_eurchf,
                                                            p_eurjpy, p_gbpchf,
                                                            p_gbpjpy, p_chfjpy,
                                                            ind_usd,  ind_eur,
                                                            ind_gbp,  ind_chf, 
                                                                      ind_jpy);
 if (err_code < 0) { return(err_code); }        //    - 
 f_corr = err_code;            //    
 //   ""   USD ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_usd, idif_usd);
 //    USD  " "
 err_code = NormToTrueMax(0, n_bars, idif_usd);
 //  ""   CHF ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_chf, idif_chf);
 //    CHF  " "
 err_code = NormToTrueMax(0, n_bars, idif_chf);
 //    USDCHF,     x[]
 for (i = 0; i < n_bars; i++) { x[i] = ind_usd[i] / ind_chf[i]; }
 //    USDCHF
 err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
 //    USDCHF  " "
 err_code = NormToTrueMax(0, n_bars, idif_p);
 //----
 if (err_code > 0) { err_code = f_corr; }
 return(err_code);     //   ; f_corr -    
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//| 4.      USDJPY        |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
double p_eurusd[];  //    EURUSD (O+H+L+C)/4
double p_gbpusd[];  //    GBPUSD (O+H+L+C)/4
double p_usdchf[];  //    USDCHF (O+H+L+C)/4
double p_usdjpy[];  //    USDJPY (O+H+L+C)/4
double p_eurgbp[];  //    EURGBP (O+H+L+C)/4
double p_eurchf[];  //    EURCHF (O+H+L+C)/4
double p_eurjpy[];  //    EURJPY (O+H+L+C)/4
double p_gbpchf[];  //    GBPCHF (O+H+L+C)/4
double p_gbpjpy[];  //    GBPJPY (O+H+L+C)/4
double p_chfjpy[];  //    CHFJPY (O+H+L+C)/4
     :
int    n_bars       //     
int    dct_on       //  : 
                    // 1 - DCT, 0 -  (5 )
double eye          //  ""
double alfa         //  
double k_0          // " " (k_0 = 1.0 / point_s)
     : 
double err_code;    //   ; f_corr -   
     :
double idif_usd[];  //    - 
double idif_jpy[];  //    - 
double idif_p[];    //     USDJPY
[double x[]         //    USDJPY - ]
[double ind_usd[];  //   USD - ]
[double ind_eur[];  //   EUR - ]
[double ind_gbp[];  //   GBP - ]
[double ind_chf[];  //   CHF - ]
[double ind_jpy[];  //   JPY - ]
*/
MT4_EXPFUNC double __stdcall GetNormDiffIndexUSDJPY(int n_bars, int dct_on, 
                                                    double eye, 
                             double alfa,           double k_0,
                             double p_eurusd [],    double p_gbpusd [],
                             double p_usdchf [],    double p_usdjpy [],
                             double p_eurgbp [],    double p_eurchf [],
                             double p_eurjpy [],    double p_gbpchf [],
                             double p_gbpjpy [],    double p_chfjpy [],
                             double idif_usd[],     double idif_jpy[],
                                                    double idif_p []
                                                   )
{
 double err_code = 0;                              //   
 double f_corr   = 0;       //      
 int i;                                                 //   
 //
 // ########################### Error Definitions ###########################
 // *** :     ,  ***
 if (n_bars > NN_MAX)
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if (n_bars < NN_MIN)
 {  
	 err_code = -2;
	 return(err_code); 
 }
 // *** :  alfa = 0  eye <> 0,  ***
 if ((alfa == 0.0) && (eye != 0.0)) 
 {  
	 err_code = -3;
	 return(err_code); 
 }  
 // *** :  eye_size < 0,  ***
 if (eye < 0.0) 
 {  
	 err_code = -4;
	 return(err_code); 
 }  
 // *** :  eye_alfa < 0,  ***
 if (alfa < 0.0) 
 { 
	 err_code = -5;
	 return(err_code); 
 }    
 // #########################################################################
 //
 //----
 //  ""     USD, EUR, GBP, CHF, JPY
 err_code = GetRawClusterIndexes(n_bars, dct_on, eye, alfa, p_eurusd, p_gbpusd, 
                                                            p_usdchf, p_usdjpy,
                                                            p_eurgbp, p_eurchf,
                                                            p_eurjpy, p_gbpchf,
                                                            p_gbpjpy, p_chfjpy,
                                                            ind_usd,  ind_eur,
                                                            ind_gbp,  ind_chf, 
                                                                      ind_jpy);
 if (err_code < 0) { return(err_code); }        //    - 
 f_corr = err_code;            //    
 //   ""   USD ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_usd, idif_usd);
 //    USD  " "
 err_code = NormToTrueMax(0, n_bars, idif_usd);
 //  ""   JPY ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_jpy, idif_jpy);
 //    JPY  " "
 err_code = NormToTrueMax(0, n_bars, idif_jpy);
 //    USDJPY,     x[]
 for (i = 0; i < n_bars; i++) { x[i] = ind_usd[i] / ind_jpy[i]; }
 //    USDJPY
 err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
 //    USDJPY  " "
 err_code = NormToTrueMax(0, n_bars, idif_p);
 //----
 if (err_code > 0) { err_code = f_corr; }
 return(err_code);     //   ; f_corr -    
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//| 5.      EURGBP        |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
double p_eurusd[];  //    EURUSD (O+H+L+C)/4
double p_gbpusd[];  //    GBPUSD (O+H+L+C)/4
double p_usdchf[];  //    USDCHF (O+H+L+C)/4
double p_usdjpy[];  //    USDJPY (O+H+L+C)/4
double p_eurgbp[];  //    EURGBP (O+H+L+C)/4
double p_eurchf[];  //    EURCHF (O+H+L+C)/4
double p_eurjpy[];  //    EURJPY (O+H+L+C)/4
double p_gbpchf[];  //    GBPCHF (O+H+L+C)/4
double p_gbpjpy[];  //    GBPJPY (O+H+L+C)/4
double p_chfjpy[];  //    CHFJPY (O+H+L+C)/4
     :
int    n_bars       //     
int    dct_on       //  : 
                    // 1 - DCT, 0 -  (5 )
double eye          //  ""
double alfa         //  
double k_0          // " " (k_0 = 1.0 / point_s)
     : 
double err_code;    //   ; f_corr -   
     :
double idif_eur[];  //    - 
double idif_gbp[];  //    - 
double idif_p[];    //     EURGBP
[double x[]         //    EURGBP - ]
[double ind_usd[];  //   USD - ]
[double ind_eur[];  //   EUR - ]
[double ind_gbp[];  //   GBP - ]
[double ind_chf[];  //   CHF - ]
[double ind_jpy[];  //   JPY - ]
*/
MT4_EXPFUNC double __stdcall GetNormDiffIndexEURGBP(int n_bars, int dct_on, 
                                                    double eye, 
                             double alfa,           double k_0,
                             double p_eurusd [],    double p_gbpusd [],
                             double p_usdchf [],    double p_usdjpy [],
                             double p_eurgbp [],    double p_eurchf [],
                             double p_eurjpy [],    double p_gbpchf [],
                             double p_gbpjpy [],    double p_chfjpy [],
                             double idif_eur[],     double idif_gbp[],
                                                    double idif_p  []
                                                   )
{
 double err_code = 0;                              //   
 double f_corr   = 0;       //      
 int i;                                                 //   
 //
 // ########################### Error Definitions ###########################
 // *** :     ,  ***
 if (n_bars > NN_MAX)
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if (n_bars < NN_MIN)
 {  
	 err_code = -2;
	 return(err_code); 
 }
 // *** :  alfa = 0  eye <> 0,  ***
 if ((alfa == 0.0) && (eye != 0.0)) 
 {  
	 err_code = -3;
	 return(err_code); 
 }  
 // *** :  eye_size < 0,  ***
 if (eye < 0.0) 
 {  
	 err_code = -4;
	 return(err_code); 
 }  
 // *** :  eye_alfa < 0,  ***
 if (alfa < 0.0) 
 { 
	 err_code = -5;
	 return(err_code); 
 }    
 // #########################################################################
 //
 //----
 //  ""     USD, EUR, GBP, CHF, JPY
 err_code = GetRawClusterIndexes(n_bars, dct_on, eye, alfa, p_eurusd, p_gbpusd, 
                                                            p_usdchf, p_usdjpy,
                                                            p_eurgbp, p_eurchf,
                                                            p_eurjpy, p_gbpchf,
                                                            p_gbpjpy, p_chfjpy,
                                                            ind_usd,  ind_eur,
                                                            ind_gbp,  ind_chf, 
                                                                      ind_jpy);
 if (err_code < 0) { return(err_code); }        //    - 
 f_corr = err_code;            //    
 //   ""   EUR ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_eur, idif_eur);
 //    EUR  " "
 err_code = NormToTrueMax(0, n_bars, idif_eur);
 //  ""   GBP ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_gbp, idif_gbp);
 //    GBP  " "
 err_code = NormToTrueMax(0, n_bars, idif_gbp);
 //    EURGBP,     x[]
 for (i = 0; i < n_bars; i++) { x[i] = ind_eur[i] / ind_gbp[i]; }
 //    EURGBP
 err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
 //    EURGBP  " "
 err_code = NormToTrueMax(0, n_bars, idif_p);
 //----
 if (err_code > 0) { err_code = f_corr; }
 return(err_code);     //   ; f_corr -    
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//| 6.      EURCHF        |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
double p_eurusd[];  //    EURUSD (O+H+L+C)/4
double p_gbpusd[];  //    GBPUSD (O+H+L+C)/4
double p_usdchf[];  //    USDCHF (O+H+L+C)/4
double p_usdjpy[];  //    USDJPY (O+H+L+C)/4
double p_eurgbp[];  //    EURGBP (O+H+L+C)/4
double p_eurchf[];  //    EURCHF (O+H+L+C)/4
double p_eurjpy[];  //    EURJPY (O+H+L+C)/4
double p_gbpchf[];  //    GBPCHF (O+H+L+C)/4
double p_gbpjpy[];  //    GBPJPY (O+H+L+C)/4
double p_chfjpy[];  //    CHFJPY (O+H+L+C)/4
     :
int    n_bars       //     
int    dct_on       //  : 
                    // 1 - DCT, 0 -  (5 )
double eye          //  ""
double alfa         //  
double k_0          // " " (k_0 = 1.0 / point_s)
     : 
double err_code;    //   ; f_corr -   
     :
double idif_n[];    //    - 
double idif_eur[];  //    - 
double idif_chf[];  //     EURCHF
[double x[]         //    EURCHF - ]
[double ind_usd[];  //   USD - ]
[double ind_eur[];  //   EUR - ]
[double ind_gbp[];  //   GBP - ]
[double ind_chf[];  //   CHF - ]
[double ind_jpy[];  //   JPY - ]
*/
MT4_EXPFUNC double __stdcall GetNormDiffIndexEURCHF(int n_bars, int dct_on, 
                                                    double eye, 
                             double alfa,           double k_0,
                             double p_eurusd [],    double p_gbpusd [],
                             double p_usdchf [],    double p_usdjpy [],
                             double p_eurgbp [],    double p_eurchf [],
                             double p_eurjpy [],    double p_gbpchf [],
                             double p_gbpjpy [],    double p_chfjpy [],
                             double idif_eur[],     double idif_chf[],
                                                    double idif_p  []
                                                   )
{
 double err_code = 0;                              //   
 double f_corr   = 0;       //      
 int i;                                                 //   
 //
 // ########################### Error Definitions ###########################
 // *** :     ,  ***
 if (n_bars > NN_MAX)
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if (n_bars < NN_MIN)
 {  
	 err_code = -2;
	 return(err_code); 
 }
 // *** :  alfa = 0  eye <> 0,  ***
 if ((alfa == 0.0) && (eye != 0.0)) 
 {  
	 err_code = -3;
	 return(err_code); 
 }  
 // *** :  eye_size < 0,  ***
 if (eye < 0.0) 
 {  
	 err_code = -4;
	 return(err_code); 
 }  
 // *** :  eye_alfa < 0,  ***
 if (alfa < 0.0) 
 { 
	 err_code = -5;
	 return(err_code); 
 }    
 // #########################################################################
 //
 //----
 //  ""     USD, EUR, GBP, CHF, JPY
 err_code = GetRawClusterIndexes(n_bars, dct_on, eye, alfa, p_eurusd, p_gbpusd, 
                                                            p_usdchf, p_usdjpy,
                                                            p_eurgbp, p_eurchf,
                                                            p_eurjpy, p_gbpchf,
                                                            p_gbpjpy, p_chfjpy,
                                                            ind_usd,  ind_eur,
                                                            ind_gbp,  ind_chf, 
                                                                      ind_jpy);
 if (err_code < 0) { return(err_code); }        //    - 
 f_corr = err_code;            //    
 //   ""   EUR ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_eur, idif_eur);
 //    EUR  " "
 err_code = NormToTrueMax(0, n_bars, idif_eur);
 //  ""   CHF ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_chf, idif_chf);
 //    CHF  " "
 err_code = NormToTrueMax(0, n_bars, idif_chf);
 //    EURCHF,     x[]
 for (i = 0; i < n_bars; i++) { x[i] = ind_eur[i] / ind_chf[i]; }
 //    EURCHF
 err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
 //    EURCHF  " "
 err_code = NormToTrueMax(0, n_bars, idif_p);
 //----
 if (err_code > 0) { err_code = f_corr; }
 return(err_code);     //   ; f_corr -    
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//| 7.      EURJPY        |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
double p_eurusd[];  //    EURUSD (O+H+L+C)/4
double p_gbpusd[];  //    GBPUSD (O+H+L+C)/4
double p_usdchf[];  //    USDCHF (O+H+L+C)/4
double p_usdjpy[];  //    USDJPY (O+H+L+C)/4
double p_eurgbp[];  //    EURGBP (O+H+L+C)/4
double p_eurchf[];  //    EURCHF (O+H+L+C)/4
double p_eurjpy[];  //    EURJPY (O+H+L+C)/4
double p_gbpchf[];  //    GBPCHF (O+H+L+C)/4
double p_gbpjpy[];  //    GBPJPY (O+H+L+C)/4
double p_chfjpy[];  //    CHFJPY (O+H+L+C)/4
     :
int    n_bars       //     
int    dct_on       //  : 
                    // 1 - DCT, 0 -  (5 )
double eye          //  ""
double alfa         //  
double k_0          // " " (k_0 = 1.0 / point_s)
     : 
double err_code;    //   ; f_corr -   
     :
double idif_jpy[];  //    - 
double idif_eur[];  //    - 
double idif_p[];    //     EURJPY
[double x[]         //    EURJPY - ]
[double ind_usd[];  //   USD - ]
[double ind_eur[];  //   EUR - ]
[double ind_gbp[];  //   GBP - ]
[double ind_chf[];  //   CHF - ]
[double ind_jpy[];  //   JPY - ]
*/
MT4_EXPFUNC double __stdcall GetNormDiffIndexEURJPY(int n_bars, int dct_on, 
                                                    double eye, 
                             double alfa,           double k_0,
                             double p_eurusd [],    double p_gbpusd [],
                             double p_usdchf [],    double p_usdjpy [],
                             double p_eurgbp [],    double p_eurchf [],
                             double p_eurjpy [],    double p_gbpchf [],
                             double p_gbpjpy [],    double p_chfjpy [],
                             double idif_eur[],     double idif_jpy[],
                                                    double idif_p  []
                                                   )
{
 double err_code = 0;                              //   
 double f_corr   = 0;       //      
 int i;                                                 //   
 //
 // ########################### Error Definitions ###########################
 // *** :     ,  ***
 if (n_bars > NN_MAX)
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if (n_bars < NN_MIN)
 {  
	 err_code = -2;
	 return(err_code); 
 }
 // *** :  alfa = 0  eye <> 0,  ***
 if ((alfa == 0.0) && (eye != 0.0)) 
 {  
	 err_code = -3;
	 return(err_code); 
 }  
 // *** :  eye_size < 0,  ***
 if (eye < 0.0) 
 {  
	 err_code = -4;
	 return(err_code); 
 }  
 // *** :  eye_alfa < 0,  ***
 if (alfa < 0.0) 
 { 
	 err_code = -5;
	 return(err_code); 
 }    
 // #########################################################################
 //
 //----
 //  ""     USD, EUR, GBP, CHF, JPY
 err_code = GetRawClusterIndexes(n_bars, dct_on, eye, alfa, p_eurusd, p_gbpusd, 
                                                            p_usdchf, p_usdjpy,
                                                            p_eurgbp, p_eurchf,
                                                            p_eurjpy, p_gbpchf,
                                                            p_gbpjpy, p_chfjpy,
                                                            ind_usd,  ind_eur,
                                                            ind_gbp,  ind_chf, 
                                                                      ind_jpy);
 if (err_code < 0) { return(err_code); }        //    - 
 f_corr = err_code;            //    
 //   ""   EUR ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_eur, idif_eur);
 //    EUR  " "
 err_code = NormToTrueMax(0, n_bars, idif_eur);
 //  ""   JPY ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_jpy, idif_jpy);
 //    JPY  " "
 err_code = NormToTrueMax(0, n_bars, idif_jpy);
 //    EURJPY,     x[]
 for (i = 0; i < n_bars; i++) { x[i] = ind_eur[i] / ind_jpy[i]; }
 //    EURJPY
 err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
 //    EURJPY  " "
 err_code = NormToTrueMax(0, n_bars, idif_p);
 //----
 if (err_code > 0) { err_code = f_corr; }
 return(err_code);     //   ; f_corr -    
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//| 8.      GBPCHF        |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
double p_eurusd[];  //    EURUSD (O+H+L+C)/4
double p_gbpusd[];  //    GBPUSD (O+H+L+C)/4
double p_usdchf[];  //    USDCHF (O+H+L+C)/4
double p_usdjpy[];  //    USDJPY (O+H+L+C)/4
double p_eurgbp[];  //    EURGBP (O+H+L+C)/4
double p_eurchf[];  //    EURCHF (O+H+L+C)/4
double p_eurjpy[];  //    EURJPY (O+H+L+C)/4
double p_gbpchf[];  //    GBPCHF (O+H+L+C)/4
double p_gbpjpy[];  //    GBPJPY (O+H+L+C)/4
double p_chfjpy[];  //    CHFJPY (O+H+L+C)/4
     :
int    n_bars       //     
int    dct_on       //  : 
                    // 1 - DCT, 0 -  (5 )
double eye          //  ""
double alfa         //  
double k_0          // " " (k_0 = 1.0 / point_s)
     : 
double err_code;    //   ; f_corr -   
     :
double idif_gbp[];  //    - 
double idif_chf[];  //    - 
double idif_p[];    //     GBPCHF
[double x[]         //    GBPCHF - ]
[double ind_usd[];  //   USD - ]
[double ind_eur[];  //   EUR - ]
[double ind_gbp[];  //   GBP - ]
[double ind_chf[];  //   CHF - ]
[double ind_jpy[];  //   JPY - ]
*/
MT4_EXPFUNC double __stdcall GetNormDiffIndexGBPCHF(int n_bars, int dct_on, 
                                                    double eye, 
                             double alfa,           double k_0,
                             double p_eurusd [],    double p_gbpusd [],
                             double p_usdchf [],    double p_usdjpy [],
                             double p_eurgbp [],    double p_eurchf [],
                             double p_eurjpy [],    double p_gbpchf [],
                             double p_gbpjpy [],    double p_chfjpy [],
                             double idif_gbp[],     double idif_chf[],
                                                    double idif_p  []
                                                   )
{
 double err_code = 0;                              //   
 double f_corr   = 0;       //      
 int i;                                                 //   
 //
 // ########################### Error Definitions ###########################
 // *** :     ,  ***
 if (n_bars > NN_MAX)
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if (n_bars < NN_MIN)
 {  
	 err_code = -2;
	 return(err_code); 
 }
 // *** :  alfa = 0  eye <> 0,  ***
 if ((alfa == 0.0) && (eye != 0.0)) 
 {  
	 err_code = -3;
	 return(err_code); 
 }  
 // *** :  eye_size < 0,  ***
 if (eye < 0.0) 
 {  
	 err_code = -4;
	 return(err_code); 
 }  
 // *** :  eye_alfa < 0,  ***
 if (alfa < 0.0) 
 { 
	 err_code = -5;
	 return(err_code); 
 }    
 // #########################################################################
 //
 //----
 //  ""     USD, EUR, GBP, CHF, JPY
 err_code = GetRawClusterIndexes(n_bars, dct_on, eye, alfa, p_eurusd, p_gbpusd, 
                                                            p_usdchf, p_usdjpy,
                                                            p_eurgbp, p_eurchf,
                                                            p_eurjpy, p_gbpchf,
                                                            p_gbpjpy, p_chfjpy,
                                                            ind_usd,  ind_eur,
                                                            ind_gbp,  ind_chf, 
                                                                      ind_jpy);
 if (err_code < 0) { return(err_code); }        //    - 
 f_corr = err_code;            //    
 //   ""   GBP ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_gbp, idif_gbp);
 //    GBP  " "
 err_code = NormToTrueMax(0, n_bars, idif_gbp);
 //  ""   CHF ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_chf, idif_chf);
 //    CHF  " "
 err_code = NormToTrueMax(0, n_bars, idif_chf);
 //    GBPCHF,     x[]
 for (i = 0; i < n_bars; i++) { x[i] = ind_gbp[i] / ind_chf[i]; }
 //    GBPCHF
 err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
 //    GBPCHF  " "
 err_code = NormToTrueMax(0, n_bars, idif_p);
 //----
 if (err_code > 0) { err_code = f_corr; }
 return(err_code);     //   ; f_corr -    
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//| 9.      GBPJPY        |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
double p_eurusd[];  //    EURUSD (O+H+L+C)/4
double p_gbpusd[];  //    GBPUSD (O+H+L+C)/4
double p_usdchf[];  //    USDCHF (O+H+L+C)/4
double p_usdjpy[];  //    USDJPY (O+H+L+C)/4
double p_eurgbp[];  //    EURGBP (O+H+L+C)/4
double p_eurchf[];  //    EURCHF (O+H+L+C)/4
double p_eurjpy[];  //    EURJPY (O+H+L+C)/4
double p_gbpchf[];  //    GBPCHF (O+H+L+C)/4
double p_gbpjpy[];  //    GBPJPY (O+H+L+C)/4
double p_chfjpy[];  //    CHFJPY (O+H+L+C)/4
     :
int    n_bars       //     
int    dct_on       //  : 
                    // 1 - DCT, 0 -  (5 )
double eye          //  ""
double alfa         //  
double k_0          // " " (k_0 = 1.0 / point_s)
     : 
double err_code;    //   ; f_corr -   
     :
double idif_gbp[];  //    - 
double idif_jpy[];  //    - 
double idif_p[];    //     GBPJPY
[double x[]         //    GBPJPY - ]
[double ind_usd[];  //   USD - ]
[double ind_eur[];  //   EUR - ]
[double ind_gbp[];  //   GBP - ]
[double ind_chf[];  //   CHF - ]
[double ind_jpy[];  //   JPY - ]
*/
MT4_EXPFUNC double __stdcall GetNormDiffIndexGBPJPY(int n_bars, int dct_on, 
                                                    double eye, 
                             double alfa,           double k_0,
                             double p_eurusd [],    double p_gbpusd [],
                             double p_usdchf [],    double p_usdjpy [],
                             double p_eurgbp [],    double p_eurchf [],
                             double p_eurjpy [],    double p_gbpchf [],
                             double p_gbpjpy [],    double p_chfjpy [],
                             double idif_gbp[],     double idif_jpy[],
                                                    double idif_p  []
                                                   )
{
 double err_code = 0;                              //   
 double f_corr   = 0;       //      
 int i;                                                 //   
 //
 // ########################### Error Definitions ###########################
 // *** :     ,  ***
 if (n_bars > NN_MAX)
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if (n_bars < NN_MIN)
 {  
	 err_code = -2;
	 return(err_code); 
 }
 // *** :  alfa = 0  eye <> 0,  ***
 if ((alfa == 0.0) && (eye != 0.0)) 
 {  
	 err_code = -3;
	 return(err_code); 
 }  
 // *** :  eye_size < 0,  ***
 if (eye < 0.0) 
 {  
	 err_code = -4;
	 return(err_code); 
 }  
 // *** :  eye_alfa < 0,  ***
 if (alfa < 0.0) 
 { 
	 err_code = -5;
	 return(err_code); 
 }    
 // #########################################################################
 //
 //----
 //  ""     USD, EUR, GBP, CHF, JPY
 err_code = GetRawClusterIndexes(n_bars, dct_on, eye, alfa, p_eurusd, p_gbpusd, 
                                                            p_usdchf, p_usdjpy,
                                                            p_eurgbp, p_eurchf,
                                                            p_eurjpy, p_gbpchf,
                                                            p_gbpjpy, p_chfjpy,
                                                            ind_usd,  ind_eur,
                                                            ind_gbp,  ind_chf, 
                                                                      ind_jpy);
 if (err_code < 0) { return(err_code); }        //    - 
 f_corr = err_code;            //    
 //   ""   GBP ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_gbp, idif_gbp);
 //    GBP  " "
 err_code = NormToTrueMax(0, n_bars, idif_gbp);
 //  ""   JPY ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_jpy, idif_jpy);
 //    JPY  " "
 err_code = NormToTrueMax(0, n_bars, idif_jpy);
 //    GBPJPY,     x[]
 for (i = 0; i < n_bars; i++) { x[i] = ind_gbp[i] / ind_jpy[i]; }
 //    GBPJPY
 err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
 //    GBPJPY  " "
 err_code = NormToTrueMax(0, n_bars, idif_p);
 //----
 if (err_code > 0) { err_code = f_corr; }
 return(err_code);     //   ; f_corr -    
}
//
//*************************************************************************//
/////////////////////////////////////////////////////////////////////////////
//+-----------------------------------------------------------------------+//
//| 10.      CHFJPY       |//
//+-----------------------------------------------------------------------+//
/////////////////////////////////////////////////////////////////////////////
/*
     :
double p_eurusd[];  //    EURUSD (O+H+L+C)/4
double p_gbpusd[];  //    GBPUSD (O+H+L+C)/4
double p_usdchf[];  //    USDCHF (O+H+L+C)/4
double p_usdjpy[];  //    USDJPY (O+H+L+C)/4
double p_eurgbp[];  //    EURGBP (O+H+L+C)/4
double p_eurchf[];  //    EURCHF (O+H+L+C)/4
double p_eurjpy[];  //    EURJPY (O+H+L+C)/4
double p_gbpchf[];  //    GBPCHF (O+H+L+C)/4
double p_gbpjpy[];  //    GBPJPY (O+H+L+C)/4
double p_chfjpy[];  //    CHFJPY (O+H+L+C)/4
     :
int    n_bars       //     
int    dct_on       //  : 
                    // 1 - DCT, 0 -  (5 )
double eye          //  ""
double alfa         //  
double k_0          // " " (k_0 = 1.0 / point_s)
     : 
double err_code;    //   ; f_corr -   
     :
double idif_chf[];  //    - 
double idif_jpy[];  //    - 
double idif_p[];    //     CHFJPY
[double x[]         //    CHFJPY - ]
[double ind_usd[];  //   USD - ]
[double ind_eur[];  //   EUR - ]
[double ind_gbp[];  //   GBP - ]
[double ind_chf[];  //   CHF - ]
[double ind_jpy[];  //   JPY - ]
*/
MT4_EXPFUNC double __stdcall GetNormDiffIndexCHFJPY(int n_bars, int dct_on, 
                                                    double eye, 
                             double alfa,           double k_0,
                             double p_eurusd [],    double p_gbpusd [],
                             double p_usdchf [],    double p_usdjpy [],
                             double p_eurgbp [],    double p_eurchf [],
                             double p_eurjpy [],    double p_gbpchf [],
                             double p_gbpjpy [],    double p_chfjpy [],
                             double idif_chf[],     double idif_jpy[],
                                                    double idif_p  []
                                                   )
{
 double err_code = 0;                              //   
 double f_corr   = 0;       //      
 int i;                                                 //   
 //
 // ########################### Error Definitions ###########################
 // *** :     ,  ***
 if (n_bars > NN_MAX)
 { 
	 err_code = -1;
	 return(err_code); 
 } 
 // *** :      ,  ***
 if (n_bars < NN_MIN)
 {  
	 err_code = -2;
	 return(err_code); 
 }
 // *** :  alfa = 0  eye <> 0,  ***
 if ((alfa == 0.0) && (eye != 0.0)) 
 {  
	 err_code = -3;
	 return(err_code); 
 }  
 // *** :  eye_size < 0,  ***
 if (eye < 0.0) 
 {  
	 err_code = -4;
	 return(err_code); 
 }  
 // *** :  eye_alfa < 0,  ***
 if (alfa < 0.0) 
 { 
	 err_code = -5;
	 return(err_code); 
 }    
 // #########################################################################
 //
 //----
 //  ""     USD, EUR, GBP, CHF, JPY
 err_code = GetRawClusterIndexes(n_bars, dct_on, eye, alfa, p_eurusd, p_gbpusd, 
                                                            p_usdchf, p_usdjpy,
                                                            p_eurgbp, p_eurchf,
                                                            p_eurjpy, p_gbpchf,
                                                            p_gbpjpy, p_chfjpy,
                                                            ind_usd,  ind_eur,
                                                            ind_gbp,  ind_chf, 
                                                                      ind_jpy);
 if (err_code < 0) { return(err_code); }        //    - 
 f_corr = err_code;            //    
 //   ""   CHF ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_chf, idif_chf);
 //    CHF  " "
 err_code = NormToTrueMax(0, n_bars, idif_chf);
 //  ""   JPY ()
 err_code = GetFirstDeriv(0, n_bars, k_0, ind_jpy, idif_jpy);
 //    JPY  " "
 err_code = NormToTrueMax(0, n_bars, idif_jpy);
 //    CHFJPY,     x[]
 for (i = 0; i < n_bars; i++) { x[i] = ind_chf[i] / ind_jpy[i]; }
 //    CHFJPY
 err_code = GetFirstDeriv(0, n_bars, k_0, x, idif_p);
 //    CHFJPY  " "
 err_code = NormToTrueMax(0, n_bars, idif_p);
 //----
 if (err_code > 0) { err_code = f_corr; }
 return(err_code);     //   ; f_corr -    
}
//
